/* MediaPlayer.c generated by valac 0.42.3, the Vala compiler
 * generated from MediaPlayer.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gst/gst.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gst/pbutils/pbutils.h>
#include <cairo.h>


#define FEED_READER_TYPE_MEDIA_PLAYER (feed_reader_media_player_get_type ())
#define FEED_READER_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayer))
#define FEED_READER_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayerClass))
#define FEED_READER_IS_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FEED_READER_TYPE_MEDIA_PLAYER))
#define FEED_READER_IS_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FEED_READER_TYPE_MEDIA_PLAYER))
#define FEED_READER_MEDIA_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayerClass))

typedef struct _FeedReaderMediaPlayer FeedReaderMediaPlayer;
typedef struct _FeedReaderMediaPlayerClass FeedReaderMediaPlayerClass;
typedef struct _FeedReaderMediaPlayerPrivate FeedReaderMediaPlayerPrivate;

#define FEED_READER_TYPE_MEDIA_TYPE (feed_reader_media_type_get_type ())

#define FEED_READER_TYPE_DISPLAY_POSITION (feed_reader_display_position_get_type ())
enum  {
	FEED_READER_MEDIA_PLAYER_0_PROPERTY,
	FEED_READER_MEDIA_PLAYER_NUM_PROPERTIES
};
static GParamSpec* feed_reader_media_player_properties[FEED_READER_MEDIA_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block31Data Block31Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _feed_reader_media_player_inspectMediaData feed_reader_media_player_inspectMediaData;
typedef struct _Block32Data Block32Data;
enum  {
	FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL,
	FEED_READER_MEDIA_PLAYER_NUM_SIGNALS
};
static guint feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_NUM_SIGNALS] = {0};

struct _FeedReaderMediaPlayer {
	GtkBox parent_instance;
	FeedReaderMediaPlayerPrivate * priv;
};

struct _FeedReaderMediaPlayerClass {
	GtkBoxClass parent_class;
};

typedef enum  {
	FEED_READER_MEDIA_TYPE_VIDEO,
	FEED_READER_MEDIA_TYPE_AUDIO
} FeedReaderMediaType;

typedef enum  {
	FEED_READER_DISPLAY_POSITION_ALL,
	FEED_READER_DISPLAY_POSITION_POS,
	FEED_READER_DISPLAY_POSITION_LEFT
} FeedReaderDisplayPosition;

struct _FeedReaderMediaPlayerPrivate {
	GstElement* m_player;
	GtkWidget* m_videoWidget;
	GtkStack* m_playStack;
	GtkButton* m_playButton;
	GtkSpinner* m_playSpinner;
	GtkButton* m_muteButton;
	GtkButton* m_closeButton;
	GtkScale* m_scale;
	GtkButton* m_labelButton;
	GtkLabel* m_bufferLabel;
	gint m_margin;
	GtkImage* m_playIcon;
	GtkImage* m_pauseIcon;
	GtkImage* m_muteIcon;
	GtkImage* m_noiseIcon;
	GtkImage* m_closeIcon;
	gboolean m_muted;
	gdouble m_aspectRatio;
	guint m_seek_source_id;
	FeedReaderMediaType m_type;
	gchar* m_URL;
	FeedReaderDisplayPosition m_display;
};

struct _Block31Data {
	int _ref_count_;
	FeedReaderMediaPlayer* self;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	gpointer _async_data_;
};

struct _feed_reader_media_player_inspectMediaData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FeedReaderMediaPlayer* self;
	Block31Data* _data31_;
	GThreadFunc run;
	void* run_target;
	GThread* _tmp0_;
	GThread* _tmp1_;
};

struct _Block32Data {
	int _ref_count_;
	FeedReaderMediaPlayer* self;
	gdouble startValue;
};


static gint FeedReaderMediaPlayer_private_offset;
static gpointer feed_reader_media_player_parent_class = NULL;

GType feed_reader_media_player_get_type (void) G_GNUC_CONST;
GType feed_reader_media_type_get_type (void) G_GNUC_CONST;
GType feed_reader_display_position_get_type (void) G_GNUC_CONST;
FeedReaderMediaPlayer* feed_reader_media_player_new (const gchar* url);
FeedReaderMediaPlayer* feed_reader_media_player_construct (GType object_type,
                                                           const gchar* url);
static void feed_reader_media_player_inspectMedia (FeedReaderMediaPlayer* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static void feed_reader_media_player_inspectMedia_finish (FeedReaderMediaPlayer* self,
                                                   GAsyncResult* _res_);
static void __lambda97_ (FeedReaderMediaPlayer* self,
                  GObject* obj,
                  GAsyncResult* res);
static void feed_reader_media_player_buildUI (FeedReaderMediaPlayer* self);
static void ___lambda97__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void feed_reader_media_player_inspectMedia_data_free (gpointer _data);
static gboolean feed_reader_media_player_inspectMedia_co (feed_reader_media_player_inspectMediaData* _data_);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static gboolean _feed_reader_media_player_inspectMedia_co_gsource_func (gpointer self);
static void* __lambda96_ (Block31Data* _data31_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void feed_reader_logger_error (const gchar* message);
static gpointer ___lambda96__gthread_func (gpointer self);
static void feed_reader_media_player_onAllocation (FeedReaderMediaPlayer* self,
                                            GtkAllocation* allocation);
static void _feed_reader_media_player_onAllocation_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                      GtkAllocation* allocation,
                                                                      gpointer self);
static gboolean feed_reader_media_player_busCallback (FeedReaderMediaPlayer* self,
                                               GstBus* bus,
                                               GstMessage* message);
static gboolean _feed_reader_media_player_busCallback_gst_bus_func (GstBus* bus,
                                                             GstMessage* message,
                                                             gpointer self);
static gboolean __lambda98_ (FeedReaderMediaPlayer* self);
static void feed_reader_media_player_calcTime (FeedReaderMediaPlayer* self);
static gboolean ___lambda98__gsource_func (gpointer self);
static void feed_reader_media_player_togglePause (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_togglePause_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self);
#define FEED_READER_MEDIA_BUTTON_PLAY "Play"
#define FEED_READER_MEDIA_BUTTON_MUTE "Mute"
static void feed_reader_media_player_toggleMute (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_toggleMute_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void __lambda99_ (FeedReaderMediaPlayer* self);
void feed_reader_media_player_kill (FeedReaderMediaPlayer* self);
static void ___lambda99__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
#define FEED_READER_MEDIA_BUTTON_CLOSE "Close"
static gboolean feed_reader_media_player_valueChanged (FeedReaderMediaPlayer* self,
                                                GtkScrollType scroll,
                                                gdouble new_value);
static gboolean _feed_reader_media_player_valueChanged_gtk_range_change_value (GtkRange* _sender,
                                                                        GtkScrollType scroll,
                                                                        gdouble new_value,
                                                                        gpointer self);
static void feed_reader_media_player_switchDisplay (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_switchDisplay_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
#define FEED_READER_MEDIA_BUTTON_PAUSE "Pause"
static gdouble* _double_dup (gdouble* self);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
static gboolean ___lambda100_ (Block32Data* _data32_);
static void feed_reader_media_player_seek (FeedReaderMediaPlayer* self,
                                    gdouble new_value);
static gboolean ____lambda100__gsource_func (gpointer self);
#define FEED_READER_MEDIA_BUTTON_UNMUTE "Unmute"
static void feed_reader_media_player_finalize (GObject * obj);


static inline gpointer
feed_reader_media_player_get_instance_private (FeedReaderMediaPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, FeedReaderMediaPlayer_private_offset);
}


static void
__lambda97_ (FeedReaderMediaPlayer* self,
             GObject* obj,
             GAsyncResult* res)
{
#line 47 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (res != NULL);
#line 48 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_buildUI (self);
#line 49 "../src/Widgets/MediaPlayer.vala"
	g_signal_emit (self, feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL], 0);
#line 50 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_inspectMedia_finish (self, res);
#line 240 "MediaPlayer.c"
}


static void
___lambda97__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 47 "../src/Widgets/MediaPlayer.vala"
	__lambda97_ ((FeedReaderMediaPlayer*) self, source_object, res);
#line 47 "../src/Widgets/MediaPlayer.vala"
	g_object_unref (self);
#line 253 "MediaPlayer.c"
}


FeedReaderMediaPlayer*
feed_reader_media_player_construct (GType object_type,
                                    const gchar* url)
{
	FeedReaderMediaPlayer * self = NULL;
	gchar* _tmp0_;
#line 42 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 42 "../src/Widgets/MediaPlayer.vala"
	self = (FeedReaderMediaPlayer*) g_object_new (object_type, NULL);
#line 44 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_type = FEED_READER_MEDIA_TYPE_AUDIO;
#line 45 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = g_strdup (url);
#line 45 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (self->priv->m_URL);
#line 45 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_URL = _tmp0_;
#line 47 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_inspectMedia (self, ___lambda97__gasync_ready_callback, g_object_ref (self));
#line 42 "../src/Widgets/MediaPlayer.vala"
	return self;
#line 279 "MediaPlayer.c"
}


FeedReaderMediaPlayer*
feed_reader_media_player_new (const gchar* url)
{
#line 42 "../src/Widgets/MediaPlayer.vala"
	return feed_reader_media_player_construct (FEED_READER_TYPE_MEDIA_PLAYER, url);
#line 288 "MediaPlayer.c"
}


static void
feed_reader_media_player_inspectMedia_data_free (gpointer _data)
{
	feed_reader_media_player_inspectMediaData* _data_;
	_data_ = _data;
#line 16 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (_data_->self);
#line 16 "../src/Widgets/MediaPlayer.vala"
	g_slice_free (feed_reader_media_player_inspectMediaData, _data_);
#line 301 "MediaPlayer.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 16 "../src/Widgets/MediaPlayer.vala"
	return self ? g_object_ref (self) : NULL;
#line 310 "MediaPlayer.c"
}


static void
feed_reader_media_player_inspectMedia (FeedReaderMediaPlayer* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	feed_reader_media_player_inspectMediaData* _data_;
	FeedReaderMediaPlayer* _tmp0_;
#line 16 "../src/Widgets/MediaPlayer.vala"
	_data_ = g_slice_new0 (feed_reader_media_player_inspectMediaData);
#line 16 "../src/Widgets/MediaPlayer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 16 "../src/Widgets/MediaPlayer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, feed_reader_media_player_inspectMedia_data_free);
#line 16 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 16 "../src/Widgets/MediaPlayer.vala"
	_data_->self = _tmp0_;
#line 16 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_inspectMedia_co (_data_);
#line 333 "MediaPlayer.c"
}


static void
feed_reader_media_player_inspectMedia_finish (FeedReaderMediaPlayer* self,
                                              GAsyncResult* _res_)
{
	feed_reader_media_player_inspectMediaData* _data_;
#line 16 "../src/Widgets/MediaPlayer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 344 "MediaPlayer.c"
}


static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
#line 54 "../src/Widgets/MediaPlayer.vala"
	g_atomic_int_inc (&_data31_->_ref_count_);
#line 54 "../src/Widgets/MediaPlayer.vala"
	return _data31_;
#line 355 "MediaPlayer.c"
}


static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
#line 54 "../src/Widgets/MediaPlayer.vala"
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
#line 366 "MediaPlayer.c"
		FeedReaderMediaPlayer* self;
#line 54 "../src/Widgets/MediaPlayer.vala"
		self = _data31_->self;
#line 54 "../src/Widgets/MediaPlayer.vala"
		(_data31_->callback_target_destroy_notify == NULL) ? NULL : (_data31_->callback_target_destroy_notify (_data31_->callback_target), NULL);
#line 54 "../src/Widgets/MediaPlayer.vala"
		_data31_->callback = NULL;
#line 54 "../src/Widgets/MediaPlayer.vala"
		_data31_->callback_target = NULL;
#line 54 "../src/Widgets/MediaPlayer.vala"
		_data31_->callback_target_destroy_notify = NULL;
#line 54 "../src/Widgets/MediaPlayer.vala"
		_g_object_unref0 (self);
#line 54 "../src/Widgets/MediaPlayer.vala"
		g_slice_free (Block31Data, _data31_);
#line 382 "MediaPlayer.c"
	}
}


static gboolean
_feed_reader_media_player_inspectMedia_co_gsource_func (gpointer self)
{
	gboolean result;
	result = feed_reader_media_player_inspectMedia_co (self);
#line 56 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 394 "MediaPlayer.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 64 "../src/Widgets/MediaPlayer.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 403 "MediaPlayer.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 64 "../src/Widgets/MediaPlayer.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 412 "MediaPlayer.c"
}


static void*
__lambda96_ (Block31Data* _data31_)
{
	FeedReaderMediaPlayer* self;
	void* result = NULL;
	GSourceFunc _tmp16_;
	void* _tmp16__target;
	GDestroyNotify _tmp16__target_destroy_notify;
	GError * _inner_error_ = NULL;
#line 58 "../src/Widgets/MediaPlayer.vala"
	self = _data31_->self;
#line 427 "MediaPlayer.c"
	{
		GstDiscoverer* discoverer = NULL;
		GstDiscoverer* _tmp0_;
		GstDiscovererInfo* info = NULL;
		GstDiscoverer* _tmp1_;
		const gchar* _tmp2_;
		GstDiscovererInfo* _tmp3_;
		GstDiscovererInfo* _tmp4_;
		GList* _tmp5_;
#line 61 "../src/Widgets/MediaPlayer.vala"
		_tmp0_ = gst_discoverer_new ((GstClockTime) (10 * GST_SECOND), &_inner_error_);
#line 61 "../src/Widgets/MediaPlayer.vala"
		discoverer = _tmp0_;
#line 61 "../src/Widgets/MediaPlayer.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 443 "MediaPlayer.c"
			goto __catch29_g_error;
		}
#line 62 "../src/Widgets/MediaPlayer.vala"
		_tmp1_ = discoverer;
#line 62 "../src/Widgets/MediaPlayer.vala"
		_tmp2_ = self->priv->m_URL;
#line 62 "../src/Widgets/MediaPlayer.vala"
		_tmp3_ = gst_discoverer_discover_uri (_tmp1_, _tmp2_, &_inner_error_);
#line 62 "../src/Widgets/MediaPlayer.vala"
		info = _tmp3_;
#line 62 "../src/Widgets/MediaPlayer.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 62 "../src/Widgets/MediaPlayer.vala"
			_g_object_unref0 (discoverer);
#line 458 "MediaPlayer.c"
			goto __catch29_g_error;
		}
#line 64 "../src/Widgets/MediaPlayer.vala"
		_tmp4_ = info;
#line 64 "../src/Widgets/MediaPlayer.vala"
		_tmp5_ = gst_discoverer_info_get_stream_list (_tmp4_);
#line 465 "MediaPlayer.c"
		{
			GList* i_collection = NULL;
			GList* i_it = NULL;
#line 64 "../src/Widgets/MediaPlayer.vala"
			i_collection = _tmp5_;
#line 64 "../src/Widgets/MediaPlayer.vala"
			for (i_it = i_collection; i_it != NULL; i_it = i_it->next) {
#line 473 "MediaPlayer.c"
				GstDiscovererStreamInfo* _tmp6_;
				GstDiscovererStreamInfo* i = NULL;
#line 64 "../src/Widgets/MediaPlayer.vala"
				_tmp6_ = _g_object_ref0 ((GstDiscovererStreamInfo*) i_it->data);
#line 64 "../src/Widgets/MediaPlayer.vala"
				i = _tmp6_;
#line 480 "MediaPlayer.c"
				{
					GstDiscovererStreamInfo* _tmp7_;
#line 66 "../src/Widgets/MediaPlayer.vala"
					_tmp7_ = i;
#line 66 "../src/Widgets/MediaPlayer.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gst_discoverer_video_info_get_type ())) {
#line 487 "MediaPlayer.c"
						GstDiscovererVideoInfo* v = NULL;
						GstDiscovererStreamInfo* _tmp8_;
						GstDiscovererVideoInfo* _tmp9_;
						GstDiscovererVideoInfo* _tmp10_;
						GstDiscovererVideoInfo* _tmp11_;
#line 68 "../src/Widgets/MediaPlayer.vala"
						_tmp8_ = i;
#line 68 "../src/Widgets/MediaPlayer.vala"
						_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gst_discoverer_video_info_get_type (), GstDiscovererVideoInfo));
#line 68 "../src/Widgets/MediaPlayer.vala"
						v = _tmp9_;
#line 69 "../src/Widgets/MediaPlayer.vala"
						_tmp10_ = v;
#line 69 "../src/Widgets/MediaPlayer.vala"
						_tmp11_ = v;
#line 69 "../src/Widgets/MediaPlayer.vala"
						self->priv->m_aspectRatio = ((gdouble) gst_discoverer_video_info_get_width (_tmp10_)) / ((gdouble) gst_discoverer_video_info_get_height (_tmp11_));
#line 70 "../src/Widgets/MediaPlayer.vala"
						self->priv->m_type = FEED_READER_MEDIA_TYPE_VIDEO;
#line 66 "../src/Widgets/MediaPlayer.vala"
						_g_object_unref0 (v);
#line 509 "MediaPlayer.c"
					}
#line 64 "../src/Widgets/MediaPlayer.vala"
					_g_object_unref0 (i);
#line 513 "MediaPlayer.c"
				}
			}
#line 64 "../src/Widgets/MediaPlayer.vala"
			(i_collection == NULL) ? NULL : (i_collection = (_g_list_free__g_object_unref0_ (i_collection), NULL));
#line 518 "MediaPlayer.c"
		}
#line 59 "../src/Widgets/MediaPlayer.vala"
		_g_object_unref0 (info);
#line 59 "../src/Widgets/MediaPlayer.vala"
		_g_object_unref0 (discoverer);
#line 524 "MediaPlayer.c"
	}
	goto __finally29;
	__catch29_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 59 "../src/Widgets/MediaPlayer.vala"
		e = _inner_error_;
#line 59 "../src/Widgets/MediaPlayer.vala"
		_inner_error_ = NULL;
#line 76 "../src/Widgets/MediaPlayer.vala"
		_tmp12_ = e;
#line 76 "../src/Widgets/MediaPlayer.vala"
		_tmp13_ = _tmp12_->message;
#line 76 "../src/Widgets/MediaPlayer.vala"
		_tmp14_ = g_strconcat ("Unable discover_uri: ", _tmp13_, NULL);
#line 76 "../src/Widgets/MediaPlayer.vala"
		_tmp15_ = _tmp14_;
#line 76 "../src/Widgets/MediaPlayer.vala"
		feed_reader_logger_error (_tmp15_);
#line 76 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp15_);
#line 59 "../src/Widgets/MediaPlayer.vala"
		_g_error_free0 (e);
#line 552 "MediaPlayer.c"
	}
	__finally29:
#line 59 "../src/Widgets/MediaPlayer.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 59 "../src/Widgets/MediaPlayer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 59 "../src/Widgets/MediaPlayer.vala"
		g_clear_error (&_inner_error_);
#line 59 "../src/Widgets/MediaPlayer.vala"
		return NULL;
#line 563 "MediaPlayer.c"
	}
#line 78 "../src/Widgets/MediaPlayer.vala"
	_tmp16_ = _data31_->callback;
#line 78 "../src/Widgets/MediaPlayer.vala"
	_tmp16__target = _data31_->callback_target;
#line 78 "../src/Widgets/MediaPlayer.vala"
	_tmp16__target_destroy_notify = _data31_->callback_target_destroy_notify;
#line 78 "../src/Widgets/MediaPlayer.vala"
	_data31_->callback = NULL;
#line 78 "../src/Widgets/MediaPlayer.vala"
	_data31_->callback_target = NULL;
#line 78 "../src/Widgets/MediaPlayer.vala"
	_data31_->callback_target_destroy_notify = NULL;
#line 78 "../src/Widgets/MediaPlayer.vala"
	g_idle_add_full (G_PRIORITY_HIGH_IDLE, _tmp16_, _tmp16__target, _tmp16__target_destroy_notify);
#line 79 "../src/Widgets/MediaPlayer.vala"
	result = NULL;
#line 79 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 583 "MediaPlayer.c"
}


static gpointer
___lambda96__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda96_ (self);
#line 58 "../src/Widgets/MediaPlayer.vala"
	block31_data_unref (self);
#line 58 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 596 "MediaPlayer.c"
}


static gboolean
feed_reader_media_player_inspectMedia_co (feed_reader_media_player_inspectMediaData* _data_)
{
#line 54 "../src/Widgets/MediaPlayer.vala"
	switch (_data_->_state_) {
#line 54 "../src/Widgets/MediaPlayer.vala"
		case 0:
#line 607 "MediaPlayer.c"
		goto _state_0;
#line 54 "../src/Widgets/MediaPlayer.vala"
		case 1:
#line 611 "MediaPlayer.c"
		goto _state_1;
		default:
#line 54 "../src/Widgets/MediaPlayer.vala"
		g_assert_not_reached ();
#line 616 "MediaPlayer.c"
	}
	_state_0:
#line 54 "../src/Widgets/MediaPlayer.vala"
	_data_->_data31_ = g_slice_new0 (Block31Data);
#line 54 "../src/Widgets/MediaPlayer.vala"
	_data_->_data31_->_ref_count_ = 1;
#line 54 "../src/Widgets/MediaPlayer.vala"
	_data_->_data31_->self = g_object_ref (_data_->self);
#line 54 "../src/Widgets/MediaPlayer.vala"
	_data_->_data31_->_async_data_ = _data_;
#line 56 "../src/Widgets/MediaPlayer.vala"
	_data_->_data31_->callback = _feed_reader_media_player_inspectMedia_co_gsource_func;
#line 56 "../src/Widgets/MediaPlayer.vala"
	_data_->_data31_->callback_target = _data_;
#line 56 "../src/Widgets/MediaPlayer.vala"
	_data_->_data31_->callback_target_destroy_notify = NULL;
#line 58 "../src/Widgets/MediaPlayer.vala"
	_data_->run = ___lambda96__gthread_func;
#line 58 "../src/Widgets/MediaPlayer.vala"
	_data_->run_target = block31_data_ref (_data_->_data31_);
#line 82 "../src/Widgets/MediaPlayer.vala"
	_data_->_tmp0_ = g_thread_new ("inspectMedia", _data_->run, _data_->run_target);
#line 82 "../src/Widgets/MediaPlayer.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 82 "../src/Widgets/MediaPlayer.vala"
	_g_thread_unref0 (_data_->_tmp1_);
#line 83 "../src/Widgets/MediaPlayer.vala"
	_data_->_state_ = 1;
#line 83 "../src/Widgets/MediaPlayer.vala"
	return FALSE;
#line 647 "MediaPlayer.c"
	_state_1:
	;
#line 54 "../src/Widgets/MediaPlayer.vala"
	block31_data_unref (_data_->_data31_);
#line 54 "../src/Widgets/MediaPlayer.vala"
	_data_->_data31_ = NULL;
#line 54 "../src/Widgets/MediaPlayer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 54 "../src/Widgets/MediaPlayer.vala"
	if (_data_->_state_ != 0) {
#line 54 "../src/Widgets/MediaPlayer.vala"
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
#line 54 "../src/Widgets/MediaPlayer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 662 "MediaPlayer.c"
		}
	}
#line 54 "../src/Widgets/MediaPlayer.vala"
	g_object_unref (_data_->_async_result);
#line 54 "../src/Widgets/MediaPlayer.vala"
	return FALSE;
#line 669 "MediaPlayer.c"
}


static void
_feed_reader_media_player_onAllocation_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                 GtkAllocation* allocation,
                                                                 gpointer self)
{
#line 93 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_onAllocation ((FeedReaderMediaPlayer*) self, allocation);
#line 680 "MediaPlayer.c"
}


static gboolean
_feed_reader_media_player_busCallback_gst_bus_func (GstBus* bus,
                                                    GstMessage* message,
                                                    gpointer self)
{
	gboolean result;
	result = feed_reader_media_player_busCallback ((FeedReaderMediaPlayer*) self, bus, message);
#line 101 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 693 "MediaPlayer.c"
}


static gboolean
__lambda98_ (FeedReaderMediaPlayer* self)
{
	gboolean result = FALSE;
	GstState state = 0;
	GstState pending = 0;
	GstElement* _tmp0_;
	GstState _tmp1_ = 0;
	GstState _tmp2_ = 0;
	GstState _tmp3_;
#line 106 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 106 "../src/Widgets/MediaPlayer.vala"
	gst_element_get_state (_tmp0_, &_tmp1_, &_tmp2_, (GstClockTime) 1000);
#line 106 "../src/Widgets/MediaPlayer.vala"
	state = _tmp1_;
#line 106 "../src/Widgets/MediaPlayer.vala"
	pending = _tmp2_;
#line 107 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = state;
#line 107 "../src/Widgets/MediaPlayer.vala"
	if (_tmp3_ == GST_STATE_PLAYING) {
#line 719 "MediaPlayer.c"
		gint64 pos = 0LL;
		gint64 dur = 0LL;
		GstElement* _tmp4_;
		gint64 _tmp5_ = 0LL;
		GstElement* _tmp6_;
		gint64 _tmp7_ = 0LL;
		gdouble position = 0.0;
		gint64 _tmp8_;
		gdouble duration = 0.0;
		gint64 _tmp9_;
		gdouble percent = 0.0;
		gdouble _tmp10_;
		gdouble _tmp11_;
		guint _tmp12_;
#line 111 "../src/Widgets/MediaPlayer.vala"
		_tmp4_ = self->priv->m_player;
#line 111 "../src/Widgets/MediaPlayer.vala"
		gst_element_query_position (_tmp4_, GST_FORMAT_TIME, &_tmp5_);
#line 111 "../src/Widgets/MediaPlayer.vala"
		pos = _tmp5_;
#line 112 "../src/Widgets/MediaPlayer.vala"
		_tmp6_ = self->priv->m_player;
#line 112 "../src/Widgets/MediaPlayer.vala"
		gst_element_query_duration (_tmp6_, GST_FORMAT_TIME, &_tmp7_);
#line 112 "../src/Widgets/MediaPlayer.vala"
		dur = _tmp7_;
#line 113 "../src/Widgets/MediaPlayer.vala"
		_tmp8_ = pos;
#line 113 "../src/Widgets/MediaPlayer.vala"
		position = ((gdouble) _tmp8_) / 1000000000;
#line 114 "../src/Widgets/MediaPlayer.vala"
		_tmp9_ = dur;
#line 114 "../src/Widgets/MediaPlayer.vala"
		duration = ((gdouble) _tmp9_) / 1000000000;
#line 115 "../src/Widgets/MediaPlayer.vala"
		_tmp10_ = position;
#line 115 "../src/Widgets/MediaPlayer.vala"
		_tmp11_ = duration;
#line 115 "../src/Widgets/MediaPlayer.vala"
		percent = (_tmp10_ * 100.0) / _tmp11_;
#line 116 "../src/Widgets/MediaPlayer.vala"
		_tmp12_ = self->priv->m_seek_source_id;
#line 116 "../src/Widgets/MediaPlayer.vala"
		if (_tmp12_ == ((guint) 0)) {
#line 764 "MediaPlayer.c"
			GtkScale* _tmp13_;
			gdouble _tmp14_;
#line 117 "../src/Widgets/MediaPlayer.vala"
			_tmp13_ = self->priv->m_scale;
#line 117 "../src/Widgets/MediaPlayer.vala"
			_tmp14_ = percent;
#line 117 "../src/Widgets/MediaPlayer.vala"
			gtk_range_set_value ((GtkRange*) _tmp13_, _tmp14_);
#line 773 "MediaPlayer.c"
		}
#line 118 "../src/Widgets/MediaPlayer.vala"
		feed_reader_media_player_calcTime (self);
#line 777 "MediaPlayer.c"
	}
#line 120 "../src/Widgets/MediaPlayer.vala"
	result = TRUE;
#line 120 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 783 "MediaPlayer.c"
}


static gboolean
___lambda98__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda98_ ((FeedReaderMediaPlayer*) self);
#line 103 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 794 "MediaPlayer.c"
}


static void
_feed_reader_media_player_togglePause_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self)
{
#line 131 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_togglePause ((FeedReaderMediaPlayer*) self);
#line 804 "MediaPlayer.c"
}


static void
_feed_reader_media_player_toggleMute_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 146 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_toggleMute ((FeedReaderMediaPlayer*) self);
#line 814 "MediaPlayer.c"
}


static void
__lambda99_ (FeedReaderMediaPlayer* self)
{
#line 154 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_kill (self);
#line 823 "MediaPlayer.c"
}


static void
___lambda99__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 153 "../src/Widgets/MediaPlayer.vala"
	__lambda99_ ((FeedReaderMediaPlayer*) self);
#line 833 "MediaPlayer.c"
}


static gboolean
_feed_reader_media_player_valueChanged_gtk_range_change_value (GtkRange* _sender,
                                                               GtkScrollType scroll,
                                                               gdouble new_value,
                                                               gpointer self)
{
	gboolean result;
	result = feed_reader_media_player_valueChanged ((FeedReaderMediaPlayer*) self, scroll, new_value);
#line 164 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 847 "MediaPlayer.c"
}


static void
_feed_reader_media_player_switchDisplay_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
#line 169 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_switchDisplay ((FeedReaderMediaPlayer*) self);
#line 857 "MediaPlayer.c"
}


static void
feed_reader_media_player_buildUI (FeedReaderMediaPlayer* self)
{
	GstElement* gtksink = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GtkWidget* _tmp2_;
	gint _tmp3_;
	GtkWidget* _tmp4_;
	gint _tmp5_;
	GtkWidget* _tmp6_;
	gint _tmp7_;
	GtkWidget* _tmp8_;
	GstElement* _tmp9_;
	GstElement* _tmp10_;
	GstElement* _tmp11_;
	GstElement* _tmp12_;
	GstElement* _tmp13_;
	const gchar* _tmp14_;
	GstBus* bus = NULL;
	GstElement* _tmp15_;
	GstBus* _tmp16_;
	GstBus* _tmp17_;
	GtkImage* _tmp18_;
	GtkImage* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkImage* _tmp22_;
	GtkButton* _tmp23_;
	GtkButton* _tmp24_;
	GtkImage* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkButton* _tmp30_;
	GtkSpinner* _tmp31_;
	GtkStack* _tmp32_;
	GtkStack* _tmp33_;
	GtkButton* _tmp34_;
	GtkStack* _tmp35_;
	GtkSpinner* _tmp36_;
	GtkStack* _tmp37_;
	GtkButton* _tmp38_;
	GtkButton* _tmp39_;
	GtkImage* _tmp40_;
	GtkButton* _tmp41_;
	GtkButton* _tmp42_;
	GtkButton* _tmp43_;
	GtkButton* _tmp44_;
	GtkButton* _tmp45_;
	GtkButton* _tmp46_;
	GtkButton* _tmp47_;
	GtkImage* _tmp48_;
	GtkButton* _tmp49_;
	GtkButton* _tmp50_;
	GtkButton* _tmp51_;
	GtkButton* _tmp52_;
	GtkButton* _tmp53_;
	GtkScale* _tmp54_;
	GtkScale* _tmp55_;
	GtkScale* _tmp56_;
	GtkScale* _tmp57_;
	GtkButton* _tmp58_;
	GtkButton* _tmp59_;
	GtkButton* _tmp60_;
	GtkStyleContext* _tmp61_;
	GtkButton* _tmp62_;
	GtkButton* _tmp63_;
	GtkButton* _tmp64_;
	GtkButton* _tmp65_;
	GtkBox* hBox = NULL;
	GtkBox* _tmp66_;
	GtkBox* _tmp67_;
	gint _tmp68_;
	GtkBox* _tmp69_;
	GtkStack* _tmp70_;
	GtkBox* _tmp71_;
	GtkButton* _tmp72_;
	GtkBox* _tmp73_;
	GtkScale* _tmp74_;
	GtkBox* _tmp75_;
	GtkButton* _tmp76_;
	GtkBox* _tmp77_;
	GtkButton* _tmp78_;
	GtkLabel* _tmp79_;
	GtkLabel* _tmp80_;
	GtkLabel* _tmp81_;
	GtkLabel* _tmp82_;
	GtkLabel* _tmp83_;
	GtkOverlay* bufferOverlay = NULL;
	GtkOverlay* _tmp84_;
	GtkOverlay* _tmp85_;
	GtkWidget* _tmp86_;
	GtkOverlay* _tmp87_;
	GtkLabel* _tmp88_;
	GtkStyleContext* _tmp89_;
	FeedReaderMediaType _tmp90_;
	GtkBox* _tmp92_;
#line 86 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = gst_element_factory_make ("gtksink", "sink");
#line 88 "../src/Widgets/MediaPlayer.vala"
	if (_tmp0_ != NULL) {
#line 88 "../src/Widgets/MediaPlayer.vala"
		g_object_ref_sink (_tmp0_);
#line 968 "MediaPlayer.c"
	}
#line 88 "../src/Widgets/MediaPlayer.vala"
	gtksink = _tmp0_;
#line 89 "../src/Widgets/MediaPlayer.vala"
	_tmp1_ = gtksink;
#line 89 "../src/Widgets/MediaPlayer.vala"
	g_object_get ((GObject*) _tmp1_, "widget", &self->priv->m_videoWidget, NULL);
#line 90 "../src/Widgets/MediaPlayer.vala"
	_tmp2_ = self->priv->m_videoWidget;
#line 90 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = self->priv->m_margin;
#line 90 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_margin_start (_tmp2_, _tmp3_);
#line 91 "../src/Widgets/MediaPlayer.vala"
	_tmp4_ = self->priv->m_videoWidget;
#line 91 "../src/Widgets/MediaPlayer.vala"
	_tmp5_ = self->priv->m_margin;
#line 91 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_margin_end (_tmp4_, _tmp5_);
#line 92 "../src/Widgets/MediaPlayer.vala"
	_tmp6_ = self->priv->m_videoWidget;
#line 92 "../src/Widgets/MediaPlayer.vala"
	_tmp7_ = self->priv->m_margin;
#line 92 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_margin_top (_tmp6_, _tmp7_);
#line 93 "../src/Widgets/MediaPlayer.vala"
	_tmp8_ = self->priv->m_videoWidget;
#line 93 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp8_, "size-allocate", (GCallback) _feed_reader_media_player_onAllocation_gtk_widget_size_allocate, self, 0);
#line 95 "../src/Widgets/MediaPlayer.vala"
	_tmp9_ = gst_element_factory_make ("playbin", "player");
#line 95 "../src/Widgets/MediaPlayer.vala"
	if (_tmp9_ != NULL) {
#line 95 "../src/Widgets/MediaPlayer.vala"
		g_object_ref_sink (_tmp9_);
#line 1004 "MediaPlayer.c"
	}
#line 95 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_player);
#line 95 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_player = _tmp9_;
#line 96 "../src/Widgets/MediaPlayer.vala"
	_tmp10_ = self->priv->m_player;
#line 96 "../src/Widgets/MediaPlayer.vala"
	_tmp11_ = gtksink;
#line 96 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GObject*) _tmp10_, "video_sink", _tmp11_, NULL);
#line 97 "../src/Widgets/MediaPlayer.vala"
	_tmp12_ = self->priv->m_player;
#line 97 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GObject*) _tmp12_, "volume", 1.0, NULL);
#line 98 "../src/Widgets/MediaPlayer.vala"
	_tmp13_ = self->priv->m_player;
#line 98 "../src/Widgets/MediaPlayer.vala"
	_tmp14_ = self->priv->m_URL;
#line 98 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GObject*) _tmp13_, "uri", _tmp14_, NULL);
#line 100 "../src/Widgets/MediaPlayer.vala"
	_tmp15_ = self->priv->m_player;
#line 100 "../src/Widgets/MediaPlayer.vala"
	_tmp16_ = gst_element_get_bus (_tmp15_);
#line 100 "../src/Widgets/MediaPlayer.vala"
	bus = _tmp16_;
#line 101 "../src/Widgets/MediaPlayer.vala"
	_tmp17_ = bus;
#line 101 "../src/Widgets/MediaPlayer.vala"
	gst_bus_add_watch_full (_tmp17_, G_PRIORITY_LOW, _feed_reader_media_player_busCallback_gst_bus_func, g_object_ref (self), g_object_unref);
#line 103 "../src/Widgets/MediaPlayer.vala"
	g_timeout_add_full (G_PRIORITY_LOW, (guint) 500, ___lambda98__gsource_func, g_object_ref (self), g_object_unref);
#line 123 "../src/Widgets/MediaPlayer.vala"
	_tmp18_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 123 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp18_);
#line 123 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playIcon);
#line 123 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playIcon = _tmp18_;
#line 124 "../src/Widgets/MediaPlayer.vala"
	_tmp19_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 124 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp19_);
#line 124 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_pauseIcon);
#line 124 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_pauseIcon = _tmp19_;
#line 125 "../src/Widgets/MediaPlayer.vala"
	_tmp20_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-muted-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
#line 125 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp20_);
#line 125 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteIcon);
#line 125 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_muteIcon = _tmp20_;
#line 126 "../src/Widgets/MediaPlayer.vala"
	_tmp21_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-high-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
#line 126 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp21_);
#line 126 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_noiseIcon);
#line 126 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_noiseIcon = _tmp21_;
#line 127 "../src/Widgets/MediaPlayer.vala"
	_tmp22_ = (GtkImage*) gtk_image_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 127 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp22_);
#line 127 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeIcon);
#line 127 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_closeIcon = _tmp22_;
#line 129 "../src/Widgets/MediaPlayer.vala"
	_tmp23_ = (GtkButton*) gtk_button_new ();
#line 129 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp23_);
#line 129 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playButton);
#line 129 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playButton = _tmp23_;
#line 130 "../src/Widgets/MediaPlayer.vala"
	_tmp24_ = self->priv->m_playButton;
#line 130 "../src/Widgets/MediaPlayer.vala"
	_tmp25_ = self->priv->m_playIcon;
#line 130 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp24_, (GtkWidget*) _tmp25_);
#line 131 "../src/Widgets/MediaPlayer.vala"
	_tmp26_ = self->priv->m_playButton;
#line 131 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp26_, "clicked", (GCallback) _feed_reader_media_player_togglePause_gtk_button_clicked, self, 0);
#line 132 "../src/Widgets/MediaPlayer.vala"
	_tmp27_ = self->priv->m_playButton;
#line 132 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp27_, FEED_READER_MEDIA_BUTTON_PLAY);
#line 133 "../src/Widgets/MediaPlayer.vala"
	_tmp28_ = self->priv->m_playButton;
#line 133 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp28_, GTK_ALIGN_CENTER);
#line 134 "../src/Widgets/MediaPlayer.vala"
	_tmp29_ = self->priv->m_playButton;
#line 134 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_CENTER);
#line 135 "../src/Widgets/MediaPlayer.vala"
	_tmp30_ = self->priv->m_playButton;
#line 135 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp30_, 48, 48);
#line 137 "../src/Widgets/MediaPlayer.vala"
	_tmp31_ = (GtkSpinner*) gtk_spinner_new ();
#line 137 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp31_);
#line 137 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playSpinner);
#line 137 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playSpinner = _tmp31_;
#line 138 "../src/Widgets/MediaPlayer.vala"
	_tmp32_ = (GtkStack*) gtk_stack_new ();
#line 138 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp32_);
#line 138 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playStack);
#line 138 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playStack = _tmp32_;
#line 139 "../src/Widgets/MediaPlayer.vala"
	_tmp33_ = self->priv->m_playStack;
#line 139 "../src/Widgets/MediaPlayer.vala"
	_tmp34_ = self->priv->m_playButton;
#line 139 "../src/Widgets/MediaPlayer.vala"
	gtk_stack_add_named (_tmp33_, (GtkWidget*) _tmp34_, "button");
#line 140 "../src/Widgets/MediaPlayer.vala"
	_tmp35_ = self->priv->m_playStack;
#line 140 "../src/Widgets/MediaPlayer.vala"
	_tmp36_ = self->priv->m_playSpinner;
#line 140 "../src/Widgets/MediaPlayer.vala"
	gtk_stack_add_named (_tmp35_, (GtkWidget*) _tmp36_, "spinner");
#line 141 "../src/Widgets/MediaPlayer.vala"
	_tmp37_ = self->priv->m_playStack;
#line 141 "../src/Widgets/MediaPlayer.vala"
	gtk_stack_set_visible_child_name (_tmp37_, "button");
#line 143 "../src/Widgets/MediaPlayer.vala"
	_tmp38_ = (GtkButton*) gtk_button_new ();
#line 143 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp38_);
#line 143 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteButton);
#line 143 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_muteButton = _tmp38_;
#line 144 "../src/Widgets/MediaPlayer.vala"
	_tmp39_ = self->priv->m_muteButton;
#line 144 "../src/Widgets/MediaPlayer.vala"
	_tmp40_ = self->priv->m_noiseIcon;
#line 144 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp39_, (GtkWidget*) _tmp40_);
#line 145 "../src/Widgets/MediaPlayer.vala"
	_tmp41_ = self->priv->m_muteButton;
#line 145 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp41_, FEED_READER_MEDIA_BUTTON_MUTE);
#line 146 "../src/Widgets/MediaPlayer.vala"
	_tmp42_ = self->priv->m_muteButton;
#line 146 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp42_, "clicked", (GCallback) _feed_reader_media_player_toggleMute_gtk_button_clicked, self, 0);
#line 147 "../src/Widgets/MediaPlayer.vala"
	_tmp43_ = self->priv->m_muteButton;
#line 147 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp43_, GTK_ALIGN_CENTER);
#line 148 "../src/Widgets/MediaPlayer.vala"
	_tmp44_ = self->priv->m_muteButton;
#line 148 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp44_, GTK_ALIGN_CENTER);
#line 149 "../src/Widgets/MediaPlayer.vala"
	_tmp45_ = self->priv->m_muteButton;
#line 149 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp45_, 48, 48);
#line 151 "../src/Widgets/MediaPlayer.vala"
	_tmp46_ = (GtkButton*) gtk_button_new ();
#line 151 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp46_);
#line 151 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeButton);
#line 151 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_closeButton = _tmp46_;
#line 152 "../src/Widgets/MediaPlayer.vala"
	_tmp47_ = self->priv->m_closeButton;
#line 152 "../src/Widgets/MediaPlayer.vala"
	_tmp48_ = self->priv->m_closeIcon;
#line 152 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp47_, (GtkWidget*) _tmp48_);
#line 153 "../src/Widgets/MediaPlayer.vala"
	_tmp49_ = self->priv->m_closeButton;
#line 153 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp49_, "clicked", (GCallback) ___lambda99__gtk_button_clicked, self, 0);
#line 156 "../src/Widgets/MediaPlayer.vala"
	_tmp50_ = self->priv->m_closeButton;
#line 156 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp50_, FEED_READER_MEDIA_BUTTON_CLOSE);
#line 157 "../src/Widgets/MediaPlayer.vala"
	_tmp51_ = self->priv->m_closeButton;
#line 157 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp51_, GTK_ALIGN_CENTER);
#line 158 "../src/Widgets/MediaPlayer.vala"
	_tmp52_ = self->priv->m_closeButton;
#line 158 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp52_, GTK_ALIGN_CENTER);
#line 159 "../src/Widgets/MediaPlayer.vala"
	_tmp53_ = self->priv->m_closeButton;
#line 159 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp53_, 48, 48);
#line 161 "../src/Widgets/MediaPlayer.vala"
	_tmp54_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, 0.0, 100.0, 5.0);
#line 161 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp54_);
#line 161 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_scale);
#line 161 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_scale = _tmp54_;
#line 162 "../src/Widgets/MediaPlayer.vala"
	_tmp55_ = self->priv->m_scale;
#line 162 "../src/Widgets/MediaPlayer.vala"
	gtk_scale_set_draw_value (_tmp55_, FALSE);
#line 163 "../src/Widgets/MediaPlayer.vala"
	_tmp56_ = self->priv->m_scale;
#line 163 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp56_, 200, 48);
#line 164 "../src/Widgets/MediaPlayer.vala"
	_tmp57_ = self->priv->m_scale;
#line 164 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object ((GtkRange*) _tmp57_, "change-value", (GCallback) _feed_reader_media_player_valueChanged_gtk_range_change_value, self, 0);
#line 166 "../src/Widgets/MediaPlayer.vala"
	_tmp58_ = (GtkButton*) gtk_button_new_with_label ("00:00");
#line 166 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp58_);
#line 166 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_labelButton);
#line 166 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_labelButton = _tmp58_;
#line 167 "../src/Widgets/MediaPlayer.vala"
	_tmp59_ = self->priv->m_labelButton;
#line 167 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_relief (_tmp59_, GTK_RELIEF_NONE);
#line 168 "../src/Widgets/MediaPlayer.vala"
	_tmp60_ = self->priv->m_labelButton;
#line 168 "../src/Widgets/MediaPlayer.vala"
	_tmp61_ = gtk_widget_get_style_context ((GtkWidget*) _tmp60_);
#line 168 "../src/Widgets/MediaPlayer.vala"
	gtk_style_context_add_class (_tmp61_, "h3");
#line 169 "../src/Widgets/MediaPlayer.vala"
	_tmp62_ = self->priv->m_labelButton;
#line 169 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp62_, "clicked", (GCallback) _feed_reader_media_player_switchDisplay_gtk_button_clicked, self, 0);
#line 170 "../src/Widgets/MediaPlayer.vala"
	_tmp63_ = self->priv->m_labelButton;
#line 170 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp63_, GTK_ALIGN_CENTER);
#line 171 "../src/Widgets/MediaPlayer.vala"
	_tmp64_ = self->priv->m_labelButton;
#line 171 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp64_, GTK_ALIGN_CENTER);
#line 172 "../src/Widgets/MediaPlayer.vala"
	_tmp65_ = self->priv->m_labelButton;
#line 172 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp65_, 48, 48);
#line 174 "../src/Widgets/MediaPlayer.vala"
	_tmp66_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 10);
#line 174 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp66_);
#line 174 "../src/Widgets/MediaPlayer.vala"
	hBox = _tmp66_;
#line 175 "../src/Widgets/MediaPlayer.vala"
	_tmp67_ = hBox;
#line 175 "../src/Widgets/MediaPlayer.vala"
	_tmp68_ = self->priv->m_margin;
#line 175 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GtkWidget*) _tmp67_, "margin", _tmp68_, NULL);
#line 176 "../src/Widgets/MediaPlayer.vala"
	_tmp69_ = hBox;
#line 176 "../src/Widgets/MediaPlayer.vala"
	_tmp70_ = self->priv->m_playStack;
#line 176 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp69_, (GtkWidget*) _tmp70_, FALSE, FALSE, (guint) 0);
#line 177 "../src/Widgets/MediaPlayer.vala"
	_tmp71_ = hBox;
#line 177 "../src/Widgets/MediaPlayer.vala"
	_tmp72_ = self->priv->m_muteButton;
#line 177 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp71_, (GtkWidget*) _tmp72_, FALSE, FALSE, (guint) 0);
#line 178 "../src/Widgets/MediaPlayer.vala"
	_tmp73_ = hBox;
#line 178 "../src/Widgets/MediaPlayer.vala"
	_tmp74_ = self->priv->m_scale;
#line 178 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp73_, (GtkWidget*) _tmp74_, TRUE, TRUE, (guint) 0);
#line 179 "../src/Widgets/MediaPlayer.vala"
	_tmp75_ = hBox;
#line 179 "../src/Widgets/MediaPlayer.vala"
	_tmp76_ = self->priv->m_labelButton;
#line 179 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp75_, (GtkWidget*) _tmp76_, FALSE, FALSE, (guint) 0);
#line 180 "../src/Widgets/MediaPlayer.vala"
	_tmp77_ = hBox;
#line 180 "../src/Widgets/MediaPlayer.vala"
	_tmp78_ = self->priv->m_closeButton;
#line 180 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp77_, (GtkWidget*) _tmp78_, FALSE, FALSE, (guint) 0);
#line 182 "../src/Widgets/MediaPlayer.vala"
	_tmp79_ = (GtkLabel*) gtk_label_new ("0%");
#line 182 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp79_);
#line 182 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_bufferLabel);
#line 182 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_bufferLabel = _tmp79_;
#line 183 "../src/Widgets/MediaPlayer.vala"
	_tmp80_ = self->priv->m_bufferLabel;
#line 183 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp80_, GTK_ALIGN_CENTER);
#line 184 "../src/Widgets/MediaPlayer.vala"
	_tmp81_ = self->priv->m_bufferLabel;
#line 184 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp81_, GTK_ALIGN_CENTER);
#line 185 "../src/Widgets/MediaPlayer.vala"
	_tmp82_ = self->priv->m_bufferLabel;
#line 185 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp82_, 48, 48);
#line 186 "../src/Widgets/MediaPlayer.vala"
	_tmp83_ = self->priv->m_bufferLabel;
#line 186 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp83_, TRUE);
#line 188 "../src/Widgets/MediaPlayer.vala"
	_tmp84_ = (GtkOverlay*) gtk_overlay_new ();
#line 188 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp84_);
#line 188 "../src/Widgets/MediaPlayer.vala"
	bufferOverlay = _tmp84_;
#line 189 "../src/Widgets/MediaPlayer.vala"
	_tmp85_ = bufferOverlay;
#line 189 "../src/Widgets/MediaPlayer.vala"
	_tmp86_ = self->priv->m_videoWidget;
#line 189 "../src/Widgets/MediaPlayer.vala"
	gtk_container_add ((GtkContainer*) _tmp85_, _tmp86_);
#line 190 "../src/Widgets/MediaPlayer.vala"
	_tmp87_ = bufferOverlay;
#line 190 "../src/Widgets/MediaPlayer.vala"
	_tmp88_ = self->priv->m_bufferLabel;
#line 190 "../src/Widgets/MediaPlayer.vala"
	gtk_overlay_add_overlay (_tmp87_, (GtkWidget*) _tmp88_);
#line 192 "../src/Widgets/MediaPlayer.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 193 "../src/Widgets/MediaPlayer.vala"
	_tmp89_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 193 "../src/Widgets/MediaPlayer.vala"
	gtk_style_context_add_class (_tmp89_, "osd");
#line 194 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GtkWidget*) self, "margin", 40, NULL);
#line 195 "../src/Widgets/MediaPlayer.vala"
	_tmp90_ = self->priv->m_type;
#line 195 "../src/Widgets/MediaPlayer.vala"
	if (_tmp90_ == FEED_READER_MEDIA_TYPE_VIDEO) {
#line 1362 "MediaPlayer.c"
		GtkOverlay* _tmp91_;
#line 196 "../src/Widgets/MediaPlayer.vala"
		_tmp91_ = bufferOverlay;
#line 196 "../src/Widgets/MediaPlayer.vala"
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp91_, TRUE, TRUE, (guint) 0);
#line 1368 "MediaPlayer.c"
	}
#line 197 "../src/Widgets/MediaPlayer.vala"
	_tmp92_ = hBox;
#line 197 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp92_, FALSE, FALSE, (guint) 0);
#line 198 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_END);
#line 199 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 86 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (bufferOverlay);
#line 86 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (hBox);
#line 86 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (bus);
#line 86 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (gtksink);
#line 1386 "MediaPlayer.c"
}


static void
feed_reader_media_player_togglePause (FeedReaderMediaPlayer* self)
{
	GstState state = 0;
	GstState pending = 0;
	GstElement* _tmp0_;
	GstState _tmp1_ = 0;
	GstState _tmp2_ = 0;
	GstState _tmp3_;
	gboolean _tmp12_;
#line 202 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 206 "../src/Widgets/MediaPlayer.vala"
	gst_element_get_state (_tmp0_, &_tmp1_, &_tmp2_, (GstClockTime) 1000);
#line 206 "../src/Widgets/MediaPlayer.vala"
	state = _tmp1_;
#line 206 "../src/Widgets/MediaPlayer.vala"
	pending = _tmp2_;
#line 208 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = state;
#line 208 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp3_) {
#line 208 "../src/Widgets/MediaPlayer.vala"
		case GST_STATE_PLAYING:
#line 1416 "MediaPlayer.c"
		{
			GtkButton* _tmp4_;
			GtkImage* _tmp5_;
			GtkButton* _tmp6_;
			GstElement* _tmp7_;
#line 211 "../src/Widgets/MediaPlayer.vala"
			_tmp4_ = self->priv->m_playButton;
#line 211 "../src/Widgets/MediaPlayer.vala"
			_tmp5_ = self->priv->m_playIcon;
#line 211 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp5_);
#line 212 "../src/Widgets/MediaPlayer.vala"
			_tmp6_ = self->priv->m_playButton;
#line 212 "../src/Widgets/MediaPlayer.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, FEED_READER_MEDIA_BUTTON_PLAY);
#line 213 "../src/Widgets/MediaPlayer.vala"
			_tmp7_ = self->priv->m_player;
#line 213 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp7_, GST_STATE_PAUSED);
#line 214 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1438 "MediaPlayer.c"
		}
		default:
#line 208 "../src/Widgets/MediaPlayer.vala"
		case GST_STATE_PAUSED:
#line 208 "../src/Widgets/MediaPlayer.vala"
		case GST_STATE_READY:
#line 1445 "MediaPlayer.c"
		{
			GtkButton* _tmp8_;
			GtkImage* _tmp9_;
			GtkButton* _tmp10_;
			GstElement* _tmp11_;
#line 219 "../src/Widgets/MediaPlayer.vala"
			_tmp8_ = self->priv->m_playButton;
#line 219 "../src/Widgets/MediaPlayer.vala"
			_tmp9_ = self->priv->m_pauseIcon;
#line 219 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_image (_tmp8_, (GtkWidget*) _tmp9_);
#line 220 "../src/Widgets/MediaPlayer.vala"
			_tmp10_ = self->priv->m_playButton;
#line 220 "../src/Widgets/MediaPlayer.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, FEED_READER_MEDIA_BUTTON_PAUSE);
#line 221 "../src/Widgets/MediaPlayer.vala"
			_tmp11_ = self->priv->m_player;
#line 221 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp11_, GST_STATE_PLAYING);
#line 222 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1467 "MediaPlayer.c"
		}
	}
#line 225 "../src/Widgets/MediaPlayer.vala"
	_tmp12_ = self->priv->m_muted;
#line 225 "../src/Widgets/MediaPlayer.vala"
	if (_tmp12_) {
#line 1474 "MediaPlayer.c"
		GstElement* _tmp13_;
#line 226 "../src/Widgets/MediaPlayer.vala"
		_tmp13_ = self->priv->m_player;
#line 226 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp13_, "volume", 0.0, NULL);
#line 1480 "MediaPlayer.c"
	} else {
		GstElement* _tmp14_;
#line 228 "../src/Widgets/MediaPlayer.vala"
		_tmp14_ = self->priv->m_player;
#line 228 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp14_, "volume", 1.0, NULL);
#line 1487 "MediaPlayer.c"
	}
}


static void
feed_reader_media_player_switchDisplay (FeedReaderMediaPlayer* self)
{
	FeedReaderDisplayPosition _tmp0_;
#line 231 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_display;
#line 233 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp0_) {
#line 233 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_ALL:
#line 1504 "MediaPlayer.c"
		{
#line 236 "../src/Widgets/MediaPlayer.vala"
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_POS;
#line 237 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1510 "MediaPlayer.c"
		}
#line 233 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_POS:
#line 1514 "MediaPlayer.c"
		{
#line 240 "../src/Widgets/MediaPlayer.vala"
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_LEFT;
#line 241 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1520 "MediaPlayer.c"
		}
#line 233 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_LEFT:
#line 1524 "MediaPlayer.c"
		{
#line 244 "../src/Widgets/MediaPlayer.vala"
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_ALL;
#line 245 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1530 "MediaPlayer.c"
		}
		default:
#line 233 "../src/Widgets/MediaPlayer.vala"
		break;
#line 1535 "MediaPlayer.c"
	}
#line 247 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_calcTime (self);
#line 1539 "MediaPlayer.c"
}


static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
#line 261 "../src/Widgets/MediaPlayer.vala"
	dup = g_new0 (gdouble, 1);
#line 261 "../src/Widgets/MediaPlayer.vala"
	memcpy (dup, self, sizeof (gdouble));
#line 261 "../src/Widgets/MediaPlayer.vala"
	return dup;
#line 1553 "MediaPlayer.c"
}


static gpointer
__double_dup0 (gpointer self)
{
#line 261 "../src/Widgets/MediaPlayer.vala"
	return self ? _double_dup (self) : NULL;
#line 1562 "MediaPlayer.c"
}


static void
feed_reader_media_player_calcTime (FeedReaderMediaPlayer* self)
{
	gint64 pos = 0LL;
	gint64 dur = 0LL;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	GstElement* _tmp2_;
	gint64 _tmp3_ = 0LL;
	gdouble position = 0.0;
	gint64 _tmp4_;
	gdouble duration = 0.0;
	gint64 _tmp5_;
	gdouble* sd = NULL;
	gdouble _tmp6_;
	gdouble* _tmp7_;
	gdouble* md = NULL;
	gdouble* hd = NULL;
	gdouble* _tmp8_;
	gdouble* sp = NULL;
	gdouble _tmp24_;
	gdouble* _tmp25_;
	gdouble* mp = NULL;
	gdouble* hp = NULL;
	gdouble* _tmp26_;
	gdouble* sr = NULL;
	gdouble _tmp42_;
	gdouble _tmp43_;
	gdouble _tmp44_;
	gdouble* _tmp45_;
	gdouble* mr = NULL;
	gdouble* hr = NULL;
	gdouble* _tmp46_;
	gchar* pLabel = NULL;
	gchar* _tmp62_;
	const gchar* _tmp63_ = NULL;
	gdouble* _tmp64_;
	const gchar* _tmp71_ = NULL;
	gdouble* _tmp72_;
	const gchar* _tmp79_ = NULL;
	gdouble* _tmp80_;
	const gchar* _tmp87_;
	gdouble* _tmp88_;
	gchar* _tmp89_;
	gchar* _tmp90_;
	gchar* _tmp91_;
	gchar* dLabel = NULL;
	gchar* _tmp92_;
	const gchar* _tmp93_ = NULL;
	gdouble* _tmp94_;
	const gchar* _tmp101_ = NULL;
	gdouble* _tmp102_;
	const gchar* _tmp109_ = NULL;
	gdouble* _tmp110_;
	const gchar* _tmp117_;
	gdouble* _tmp118_;
	gchar* _tmp119_;
	gchar* _tmp120_;
	gchar* _tmp121_;
	gchar* rLabel = NULL;
	gchar* _tmp122_;
	const gchar* _tmp123_ = NULL;
	gdouble* _tmp124_;
	const gchar* _tmp131_ = NULL;
	gdouble* _tmp132_;
	const gchar* _tmp139_ = NULL;
	gdouble* _tmp140_;
	const gchar* _tmp147_;
	gdouble* _tmp148_;
	gchar* _tmp149_;
	gchar* _tmp150_;
	gchar* _tmp151_;
	gint64 _tmp152_;
	FeedReaderDisplayPosition _tmp155_;
#line 250 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 254 "../src/Widgets/MediaPlayer.vala"
	gst_element_query_position (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 254 "../src/Widgets/MediaPlayer.vala"
	pos = _tmp1_;
#line 255 "../src/Widgets/MediaPlayer.vala"
	_tmp2_ = self->priv->m_player;
#line 255 "../src/Widgets/MediaPlayer.vala"
	gst_element_query_duration (_tmp2_, GST_FORMAT_TIME, &_tmp3_);
#line 255 "../src/Widgets/MediaPlayer.vala"
	dur = _tmp3_;
#line 256 "../src/Widgets/MediaPlayer.vala"
	_tmp4_ = pos;
#line 256 "../src/Widgets/MediaPlayer.vala"
	position = (gdouble) ((gint) (((gdouble) _tmp4_) / 1000000000));
#line 257 "../src/Widgets/MediaPlayer.vala"
	_tmp5_ = dur;
#line 257 "../src/Widgets/MediaPlayer.vala"
	duration = (gdouble) ((gint) (((gdouble) _tmp5_) / 1000000000));
#line 261 "../src/Widgets/MediaPlayer.vala"
	_tmp6_ = duration;
#line 261 "../src/Widgets/MediaPlayer.vala"
	_tmp7_ = __double_dup0 (&_tmp6_);
#line 261 "../src/Widgets/MediaPlayer.vala"
	sd = _tmp7_;
#line 262 "../src/Widgets/MediaPlayer.vala"
	md = NULL;
#line 263 "../src/Widgets/MediaPlayer.vala"
	hd = NULL;
#line 265 "../src/Widgets/MediaPlayer.vala"
	_tmp8_ = sd;
#line 265 "../src/Widgets/MediaPlayer.vala"
	if (((gint) (*_tmp8_)) >= 60) {
#line 1676 "MediaPlayer.c"
		gdouble* _tmp9_;
		gdouble _tmp10_;
		gdouble* _tmp11_;
		gdouble* _tmp12_;
		gdouble* _tmp13_;
		gdouble _tmp14_;
		gdouble* _tmp15_;
		gdouble* _tmp16_;
#line 267 "../src/Widgets/MediaPlayer.vala"
		_tmp9_ = sd;
#line 267 "../src/Widgets/MediaPlayer.vala"
		_tmp10_ = (gdouble) ((gint) ((*_tmp9_) / 60));
#line 267 "../src/Widgets/MediaPlayer.vala"
		_tmp11_ = __double_dup0 (&_tmp10_);
#line 267 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (md);
#line 267 "../src/Widgets/MediaPlayer.vala"
		md = _tmp11_;
#line 268 "../src/Widgets/MediaPlayer.vala"
		_tmp12_ = sd;
#line 268 "../src/Widgets/MediaPlayer.vala"
		_tmp13_ = md;
#line 268 "../src/Widgets/MediaPlayer.vala"
		_tmp14_ = (*_tmp12_) - ((*_tmp13_) * 60);
#line 268 "../src/Widgets/MediaPlayer.vala"
		_tmp15_ = __double_dup0 (&_tmp14_);
#line 268 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sd);
#line 268 "../src/Widgets/MediaPlayer.vala"
		sd = _tmp15_;
#line 270 "../src/Widgets/MediaPlayer.vala"
		_tmp16_ = md;
#line 270 "../src/Widgets/MediaPlayer.vala"
		if (((gint) (*_tmp16_)) >= 60) {
#line 1711 "MediaPlayer.c"
			gdouble* _tmp17_;
			gdouble _tmp18_;
			gdouble* _tmp19_;
			gdouble* _tmp20_;
			gdouble* _tmp21_;
			gdouble _tmp22_;
			gdouble* _tmp23_;
#line 272 "../src/Widgets/MediaPlayer.vala"
			_tmp17_ = md;
#line 272 "../src/Widgets/MediaPlayer.vala"
			_tmp18_ = (gdouble) ((gint) ((*_tmp17_) / 60));
#line 272 "../src/Widgets/MediaPlayer.vala"
			_tmp19_ = __double_dup0 (&_tmp18_);
#line 272 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (hd);
#line 272 "../src/Widgets/MediaPlayer.vala"
			hd = _tmp19_;
#line 273 "../src/Widgets/MediaPlayer.vala"
			_tmp20_ = md;
#line 273 "../src/Widgets/MediaPlayer.vala"
			_tmp21_ = hd;
#line 273 "../src/Widgets/MediaPlayer.vala"
			_tmp22_ = (*_tmp20_) - ((*_tmp21_) * 60);
#line 273 "../src/Widgets/MediaPlayer.vala"
			_tmp23_ = __double_dup0 (&_tmp22_);
#line 273 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (md);
#line 273 "../src/Widgets/MediaPlayer.vala"
			md = _tmp23_;
#line 1741 "MediaPlayer.c"
		}
	}
#line 277 "../src/Widgets/MediaPlayer.vala"
	_tmp24_ = position;
#line 277 "../src/Widgets/MediaPlayer.vala"
	_tmp25_ = __double_dup0 (&_tmp24_);
#line 277 "../src/Widgets/MediaPlayer.vala"
	sp = _tmp25_;
#line 278 "../src/Widgets/MediaPlayer.vala"
	mp = NULL;
#line 279 "../src/Widgets/MediaPlayer.vala"
	hp = NULL;
#line 281 "../src/Widgets/MediaPlayer.vala"
	_tmp26_ = sp;
#line 281 "../src/Widgets/MediaPlayer.vala"
	if (((gint) (*_tmp26_)) >= 60) {
#line 1758 "MediaPlayer.c"
		gdouble* _tmp27_;
		gdouble _tmp28_;
		gdouble* _tmp29_;
		gdouble* _tmp30_;
		gdouble* _tmp31_;
		gdouble _tmp32_;
		gdouble* _tmp33_;
		gdouble* _tmp34_;
#line 283 "../src/Widgets/MediaPlayer.vala"
		_tmp27_ = sp;
#line 283 "../src/Widgets/MediaPlayer.vala"
		_tmp28_ = (gdouble) ((gint) ((*_tmp27_) / 60));
#line 283 "../src/Widgets/MediaPlayer.vala"
		_tmp29_ = __double_dup0 (&_tmp28_);
#line 283 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mp);
#line 283 "../src/Widgets/MediaPlayer.vala"
		mp = _tmp29_;
#line 284 "../src/Widgets/MediaPlayer.vala"
		_tmp30_ = sp;
#line 284 "../src/Widgets/MediaPlayer.vala"
		_tmp31_ = mp;
#line 284 "../src/Widgets/MediaPlayer.vala"
		_tmp32_ = (*_tmp30_) - ((*_tmp31_) * 60);
#line 284 "../src/Widgets/MediaPlayer.vala"
		_tmp33_ = __double_dup0 (&_tmp32_);
#line 284 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sp);
#line 284 "../src/Widgets/MediaPlayer.vala"
		sp = _tmp33_;
#line 286 "../src/Widgets/MediaPlayer.vala"
		_tmp34_ = mp;
#line 286 "../src/Widgets/MediaPlayer.vala"
		if (((gint) (*_tmp34_)) >= 60) {
#line 1793 "MediaPlayer.c"
			gdouble* _tmp35_;
			gdouble _tmp36_;
			gdouble* _tmp37_;
			gdouble* _tmp38_;
			gdouble* _tmp39_;
			gdouble _tmp40_;
			gdouble* _tmp41_;
#line 288 "../src/Widgets/MediaPlayer.vala"
			_tmp35_ = mp;
#line 288 "../src/Widgets/MediaPlayer.vala"
			_tmp36_ = (gdouble) ((gint) ((*_tmp35_) / 60));
#line 288 "../src/Widgets/MediaPlayer.vala"
			_tmp37_ = __double_dup0 (&_tmp36_);
#line 288 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (hp);
#line 288 "../src/Widgets/MediaPlayer.vala"
			hp = _tmp37_;
#line 289 "../src/Widgets/MediaPlayer.vala"
			_tmp38_ = mp;
#line 289 "../src/Widgets/MediaPlayer.vala"
			_tmp39_ = hp;
#line 289 "../src/Widgets/MediaPlayer.vala"
			_tmp40_ = (*_tmp38_) - ((*_tmp39_) * 60);
#line 289 "../src/Widgets/MediaPlayer.vala"
			_tmp41_ = __double_dup0 (&_tmp40_);
#line 289 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (mp);
#line 289 "../src/Widgets/MediaPlayer.vala"
			mp = _tmp41_;
#line 1823 "MediaPlayer.c"
		}
	}
#line 293 "../src/Widgets/MediaPlayer.vala"
	_tmp42_ = duration;
#line 293 "../src/Widgets/MediaPlayer.vala"
	_tmp43_ = position;
#line 293 "../src/Widgets/MediaPlayer.vala"
	_tmp44_ = _tmp42_ - _tmp43_;
#line 293 "../src/Widgets/MediaPlayer.vala"
	_tmp45_ = __double_dup0 (&_tmp44_);
#line 293 "../src/Widgets/MediaPlayer.vala"
	sr = _tmp45_;
#line 294 "../src/Widgets/MediaPlayer.vala"
	mr = NULL;
#line 295 "../src/Widgets/MediaPlayer.vala"
	hr = NULL;
#line 297 "../src/Widgets/MediaPlayer.vala"
	_tmp46_ = sr;
#line 297 "../src/Widgets/MediaPlayer.vala"
	if (((gint) (*_tmp46_)) >= 60) {
#line 1844 "MediaPlayer.c"
		gdouble* _tmp47_;
		gdouble _tmp48_;
		gdouble* _tmp49_;
		gdouble* _tmp50_;
		gdouble* _tmp51_;
		gdouble _tmp52_;
		gdouble* _tmp53_;
		gdouble* _tmp54_;
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp47_ = sr;
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp48_ = (gdouble) ((gint) ((*_tmp47_) / 60));
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp49_ = __double_dup0 (&_tmp48_);
#line 299 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mr);
#line 299 "../src/Widgets/MediaPlayer.vala"
		mr = _tmp49_;
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp50_ = sr;
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp51_ = mr;
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp52_ = (*_tmp50_) - ((*_tmp51_) * 60);
#line 300 "../src/Widgets/MediaPlayer.vala"
		_tmp53_ = __double_dup0 (&_tmp52_);
#line 300 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sr);
#line 300 "../src/Widgets/MediaPlayer.vala"
		sr = _tmp53_;
#line 302 "../src/Widgets/MediaPlayer.vala"
		_tmp54_ = mr;
#line 302 "../src/Widgets/MediaPlayer.vala"
		if (((gint) (*_tmp54_)) >= 60) {
#line 1879 "MediaPlayer.c"
			gdouble* _tmp55_;
			gdouble _tmp56_;
			gdouble* _tmp57_;
			gdouble* _tmp58_;
			gdouble* _tmp59_;
			gdouble _tmp60_;
			gdouble* _tmp61_;
#line 304 "../src/Widgets/MediaPlayer.vala"
			_tmp55_ = mr;
#line 304 "../src/Widgets/MediaPlayer.vala"
			_tmp56_ = (gdouble) ((gint) ((*_tmp55_) / 60));
#line 304 "../src/Widgets/MediaPlayer.vala"
			_tmp57_ = __double_dup0 (&_tmp56_);
#line 304 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (hr);
#line 304 "../src/Widgets/MediaPlayer.vala"
			hr = _tmp57_;
#line 305 "../src/Widgets/MediaPlayer.vala"
			_tmp58_ = mr;
#line 305 "../src/Widgets/MediaPlayer.vala"
			_tmp59_ = hr;
#line 305 "../src/Widgets/MediaPlayer.vala"
			_tmp60_ = (*_tmp58_) - ((*_tmp59_) * 60);
#line 305 "../src/Widgets/MediaPlayer.vala"
			_tmp61_ = __double_dup0 (&_tmp60_);
#line 305 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (mr);
#line 305 "../src/Widgets/MediaPlayer.vala"
			mr = _tmp61_;
#line 1909 "MediaPlayer.c"
		}
	}
#line 309 "../src/Widgets/MediaPlayer.vala"
	_tmp62_ = g_strdup ("");
#line 309 "../src/Widgets/MediaPlayer.vala"
	pLabel = _tmp62_;
#line 310 "../src/Widgets/MediaPlayer.vala"
	_tmp64_ = hp;
#line 310 "../src/Widgets/MediaPlayer.vala"
	if (_tmp64_ != NULL) {
#line 1920 "MediaPlayer.c"
		const gchar* _tmp65_;
		gdouble* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
		const gchar* _tmp70_;
#line 310 "../src/Widgets/MediaPlayer.vala"
		_tmp65_ = pLabel;
#line 310 "../src/Widgets/MediaPlayer.vala"
		_tmp66_ = hp;
#line 310 "../src/Widgets/MediaPlayer.vala"
		_tmp67_ = g_strdup_printf ("%02.0f:", *_tmp66_);
#line 310 "../src/Widgets/MediaPlayer.vala"
		_tmp68_ = _tmp67_;
#line 310 "../src/Widgets/MediaPlayer.vala"
		_tmp69_ = g_strconcat (_tmp65_, _tmp68_, NULL);
#line 310 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 310 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp69_;
#line 310 "../src/Widgets/MediaPlayer.vala"
		_tmp70_ = pLabel;
#line 310 "../src/Widgets/MediaPlayer.vala"
		_tmp63_ = _tmp70_;
#line 310 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp68_);
#line 1947 "MediaPlayer.c"
	} else {
#line 310 "../src/Widgets/MediaPlayer.vala"
		_tmp63_ = NULL;
#line 1951 "MediaPlayer.c"
	}
#line 311 "../src/Widgets/MediaPlayer.vala"
	_tmp72_ = mp;
#line 311 "../src/Widgets/MediaPlayer.vala"
	if (_tmp72_ != NULL) {
#line 1957 "MediaPlayer.c"
		const gchar* _tmp73_;
		gdouble* _tmp74_;
		gchar* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
		const gchar* _tmp78_;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp73_ = pLabel;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp74_ = mp;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp75_ = g_strdup_printf ("%02.0f", *_tmp74_);
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp76_ = _tmp75_;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp77_ = g_strconcat (_tmp73_, _tmp76_, NULL);
#line 311 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 311 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp77_;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp78_ = pLabel;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp71_ = _tmp78_;
#line 311 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp76_);
#line 1984 "MediaPlayer.c"
	} else {
#line 311 "../src/Widgets/MediaPlayer.vala"
		_tmp71_ = NULL;
#line 1988 "MediaPlayer.c"
	}
#line 312 "../src/Widgets/MediaPlayer.vala"
	_tmp80_ = mp;
#line 312 "../src/Widgets/MediaPlayer.vala"
	if (_tmp80_ != NULL) {
#line 1994 "MediaPlayer.c"
		const gchar* _tmp81_;
		gchar* _tmp82_;
		const gchar* _tmp83_;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp81_ = pLabel;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp82_ = g_strconcat (_tmp81_, ":", NULL);
#line 312 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 312 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp82_;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp83_ = pLabel;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp79_ = _tmp83_;
#line 2010 "MediaPlayer.c"
	} else {
		const gchar* _tmp84_;
		gchar* _tmp85_;
		const gchar* _tmp86_;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp84_ = pLabel;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp85_ = g_strconcat (_tmp84_, "0:", NULL);
#line 312 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 312 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp85_;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp86_ = pLabel;
#line 312 "../src/Widgets/MediaPlayer.vala"
		_tmp79_ = _tmp86_;
#line 2027 "MediaPlayer.c"
	}
#line 313 "../src/Widgets/MediaPlayer.vala"
	_tmp87_ = pLabel;
#line 313 "../src/Widgets/MediaPlayer.vala"
	_tmp88_ = sp;
#line 313 "../src/Widgets/MediaPlayer.vala"
	_tmp89_ = g_strdup_printf ("%02.0f", *_tmp88_);
#line 313 "../src/Widgets/MediaPlayer.vala"
	_tmp90_ = _tmp89_;
#line 313 "../src/Widgets/MediaPlayer.vala"
	_tmp91_ = g_strconcat (_tmp87_, _tmp90_, NULL);
#line 313 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (pLabel);
#line 313 "../src/Widgets/MediaPlayer.vala"
	pLabel = _tmp91_;
#line 313 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (_tmp90_);
#line 315 "../src/Widgets/MediaPlayer.vala"
	_tmp92_ = g_strdup ("");
#line 315 "../src/Widgets/MediaPlayer.vala"
	dLabel = _tmp92_;
#line 316 "../src/Widgets/MediaPlayer.vala"
	_tmp94_ = hd;
#line 316 "../src/Widgets/MediaPlayer.vala"
	if (_tmp94_ != NULL) {
#line 2053 "MediaPlayer.c"
		const gchar* _tmp95_;
		gdouble* _tmp96_;
		gchar* _tmp97_;
		gchar* _tmp98_;
		gchar* _tmp99_;
		const gchar* _tmp100_;
#line 316 "../src/Widgets/MediaPlayer.vala"
		_tmp95_ = dLabel;
#line 316 "../src/Widgets/MediaPlayer.vala"
		_tmp96_ = hd;
#line 316 "../src/Widgets/MediaPlayer.vala"
		_tmp97_ = g_strdup_printf ("%02.0f:", *_tmp96_);
#line 316 "../src/Widgets/MediaPlayer.vala"
		_tmp98_ = _tmp97_;
#line 316 "../src/Widgets/MediaPlayer.vala"
		_tmp99_ = g_strconcat (_tmp95_, _tmp98_, NULL);
#line 316 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 316 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp99_;
#line 316 "../src/Widgets/MediaPlayer.vala"
		_tmp100_ = dLabel;
#line 316 "../src/Widgets/MediaPlayer.vala"
		_tmp93_ = _tmp100_;
#line 316 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp98_);
#line 2080 "MediaPlayer.c"
	} else {
#line 316 "../src/Widgets/MediaPlayer.vala"
		_tmp93_ = NULL;
#line 2084 "MediaPlayer.c"
	}
#line 317 "../src/Widgets/MediaPlayer.vala"
	_tmp102_ = md;
#line 317 "../src/Widgets/MediaPlayer.vala"
	if (_tmp102_ != NULL) {
#line 2090 "MediaPlayer.c"
		const gchar* _tmp103_;
		gdouble* _tmp104_;
		gchar* _tmp105_;
		gchar* _tmp106_;
		gchar* _tmp107_;
		const gchar* _tmp108_;
#line 317 "../src/Widgets/MediaPlayer.vala"
		_tmp103_ = dLabel;
#line 317 "../src/Widgets/MediaPlayer.vala"
		_tmp104_ = md;
#line 317 "../src/Widgets/MediaPlayer.vala"
		_tmp105_ = g_strdup_printf ("%02.0f", *_tmp104_);
#line 317 "../src/Widgets/MediaPlayer.vala"
		_tmp106_ = _tmp105_;
#line 317 "../src/Widgets/MediaPlayer.vala"
		_tmp107_ = g_strconcat (_tmp103_, _tmp106_, NULL);
#line 317 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 317 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp107_;
#line 317 "../src/Widgets/MediaPlayer.vala"
		_tmp108_ = dLabel;
#line 317 "../src/Widgets/MediaPlayer.vala"
		_tmp101_ = _tmp108_;
#line 317 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp106_);
#line 2117 "MediaPlayer.c"
	} else {
#line 317 "../src/Widgets/MediaPlayer.vala"
		_tmp101_ = NULL;
#line 2121 "MediaPlayer.c"
	}
#line 318 "../src/Widgets/MediaPlayer.vala"
	_tmp110_ = md;
#line 318 "../src/Widgets/MediaPlayer.vala"
	if (_tmp110_ != NULL) {
#line 2127 "MediaPlayer.c"
		const gchar* _tmp111_;
		gchar* _tmp112_;
		const gchar* _tmp113_;
#line 318 "../src/Widgets/MediaPlayer.vala"
		_tmp111_ = dLabel;
#line 318 "../src/Widgets/MediaPlayer.vala"
		_tmp112_ = g_strconcat (_tmp111_, ":", NULL);
#line 318 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 318 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp112_;
#line 318 "../src/Widgets/MediaPlayer.vala"
		_tmp113_ = dLabel;
#line 318 "../src/Widgets/MediaPlayer.vala"
		_tmp109_ = _tmp113_;
#line 2143 "MediaPlayer.c"
	} else {
		const gchar* _tmp114_;
		gchar* _tmp115_;
		const gchar* _tmp116_;
#line 318 "../src/Widgets/MediaPlayer.vala"
		_tmp114_ = dLabel;
#line 318 "../src/Widgets/MediaPlayer.vala"
		_tmp115_ = g_strconcat (_tmp114_, "0:", NULL);
#line 318 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 318 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp115_;
#line 318 "../src/Widgets/MediaPlayer.vala"
		_tmp116_ = dLabel;
#line 318 "../src/Widgets/MediaPlayer.vala"
		_tmp109_ = _tmp116_;
#line 2160 "MediaPlayer.c"
	}
#line 319 "../src/Widgets/MediaPlayer.vala"
	_tmp117_ = dLabel;
#line 319 "../src/Widgets/MediaPlayer.vala"
	_tmp118_ = sd;
#line 319 "../src/Widgets/MediaPlayer.vala"
	_tmp119_ = g_strdup_printf ("%02.0f", *_tmp118_);
#line 319 "../src/Widgets/MediaPlayer.vala"
	_tmp120_ = _tmp119_;
#line 319 "../src/Widgets/MediaPlayer.vala"
	_tmp121_ = g_strconcat (_tmp117_, _tmp120_, NULL);
#line 319 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (dLabel);
#line 319 "../src/Widgets/MediaPlayer.vala"
	dLabel = _tmp121_;
#line 319 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (_tmp120_);
#line 321 "../src/Widgets/MediaPlayer.vala"
	_tmp122_ = g_strdup ("-");
#line 321 "../src/Widgets/MediaPlayer.vala"
	rLabel = _tmp122_;
#line 322 "../src/Widgets/MediaPlayer.vala"
	_tmp124_ = hr;
#line 322 "../src/Widgets/MediaPlayer.vala"
	if (_tmp124_ != NULL) {
#line 2186 "MediaPlayer.c"
		const gchar* _tmp125_;
		gdouble* _tmp126_;
		gchar* _tmp127_;
		gchar* _tmp128_;
		gchar* _tmp129_;
		const gchar* _tmp130_;
#line 322 "../src/Widgets/MediaPlayer.vala"
		_tmp125_ = rLabel;
#line 322 "../src/Widgets/MediaPlayer.vala"
		_tmp126_ = hr;
#line 322 "../src/Widgets/MediaPlayer.vala"
		_tmp127_ = g_strdup_printf ("%02.0f:", *_tmp126_);
#line 322 "../src/Widgets/MediaPlayer.vala"
		_tmp128_ = _tmp127_;
#line 322 "../src/Widgets/MediaPlayer.vala"
		_tmp129_ = g_strconcat (_tmp125_, _tmp128_, NULL);
#line 322 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 322 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp129_;
#line 322 "../src/Widgets/MediaPlayer.vala"
		_tmp130_ = rLabel;
#line 322 "../src/Widgets/MediaPlayer.vala"
		_tmp123_ = _tmp130_;
#line 322 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp128_);
#line 2213 "MediaPlayer.c"
	} else {
#line 322 "../src/Widgets/MediaPlayer.vala"
		_tmp123_ = NULL;
#line 2217 "MediaPlayer.c"
	}
#line 323 "../src/Widgets/MediaPlayer.vala"
	_tmp132_ = mr;
#line 323 "../src/Widgets/MediaPlayer.vala"
	if (_tmp132_ != NULL) {
#line 2223 "MediaPlayer.c"
		const gchar* _tmp133_;
		gdouble* _tmp134_;
		gchar* _tmp135_;
		gchar* _tmp136_;
		gchar* _tmp137_;
		const gchar* _tmp138_;
#line 323 "../src/Widgets/MediaPlayer.vala"
		_tmp133_ = rLabel;
#line 323 "../src/Widgets/MediaPlayer.vala"
		_tmp134_ = mr;
#line 323 "../src/Widgets/MediaPlayer.vala"
		_tmp135_ = g_strdup_printf ("%02.0f", *_tmp134_);
#line 323 "../src/Widgets/MediaPlayer.vala"
		_tmp136_ = _tmp135_;
#line 323 "../src/Widgets/MediaPlayer.vala"
		_tmp137_ = g_strconcat (_tmp133_, _tmp136_, NULL);
#line 323 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 323 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp137_;
#line 323 "../src/Widgets/MediaPlayer.vala"
		_tmp138_ = rLabel;
#line 323 "../src/Widgets/MediaPlayer.vala"
		_tmp131_ = _tmp138_;
#line 323 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp136_);
#line 2250 "MediaPlayer.c"
	} else {
#line 323 "../src/Widgets/MediaPlayer.vala"
		_tmp131_ = NULL;
#line 2254 "MediaPlayer.c"
	}
#line 324 "../src/Widgets/MediaPlayer.vala"
	_tmp140_ = mr;
#line 324 "../src/Widgets/MediaPlayer.vala"
	if (_tmp140_ != NULL) {
#line 2260 "MediaPlayer.c"
		const gchar* _tmp141_;
		gchar* _tmp142_;
		const gchar* _tmp143_;
#line 324 "../src/Widgets/MediaPlayer.vala"
		_tmp141_ = rLabel;
#line 324 "../src/Widgets/MediaPlayer.vala"
		_tmp142_ = g_strconcat (_tmp141_, ":", NULL);
#line 324 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 324 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp142_;
#line 324 "../src/Widgets/MediaPlayer.vala"
		_tmp143_ = rLabel;
#line 324 "../src/Widgets/MediaPlayer.vala"
		_tmp139_ = _tmp143_;
#line 2276 "MediaPlayer.c"
	} else {
		const gchar* _tmp144_;
		gchar* _tmp145_;
		const gchar* _tmp146_;
#line 324 "../src/Widgets/MediaPlayer.vala"
		_tmp144_ = rLabel;
#line 324 "../src/Widgets/MediaPlayer.vala"
		_tmp145_ = g_strconcat (_tmp144_, "0:", NULL);
#line 324 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 324 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp145_;
#line 324 "../src/Widgets/MediaPlayer.vala"
		_tmp146_ = rLabel;
#line 324 "../src/Widgets/MediaPlayer.vala"
		_tmp139_ = _tmp146_;
#line 2293 "MediaPlayer.c"
	}
#line 325 "../src/Widgets/MediaPlayer.vala"
	_tmp147_ = rLabel;
#line 325 "../src/Widgets/MediaPlayer.vala"
	_tmp148_ = sr;
#line 325 "../src/Widgets/MediaPlayer.vala"
	_tmp149_ = g_strdup_printf ("%02.0f", *_tmp148_);
#line 325 "../src/Widgets/MediaPlayer.vala"
	_tmp150_ = _tmp149_;
#line 325 "../src/Widgets/MediaPlayer.vala"
	_tmp151_ = g_strconcat (_tmp147_, _tmp150_, NULL);
#line 325 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (rLabel);
#line 325 "../src/Widgets/MediaPlayer.vala"
	rLabel = _tmp151_;
#line 325 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (_tmp150_);
#line 327 "../src/Widgets/MediaPlayer.vala"
	_tmp152_ = dur;
#line 327 "../src/Widgets/MediaPlayer.vala"
	if (_tmp152_ == ((gint64) -1)) {
#line 2315 "MediaPlayer.c"
		GtkButton* _tmp153_;
		const gchar* _tmp154_;
#line 329 "../src/Widgets/MediaPlayer.vala"
		_tmp153_ = self->priv->m_labelButton;
#line 329 "../src/Widgets/MediaPlayer.vala"
		_tmp154_ = pLabel;
#line 329 "../src/Widgets/MediaPlayer.vala"
		gtk_button_set_label (_tmp153_, _tmp154_);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (hr);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mr);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sr);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (hp);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mp);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sp);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (hd);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (md);
#line 330 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sd);
#line 330 "../src/Widgets/MediaPlayer.vala"
		return;
#line 2350 "MediaPlayer.c"
	}
#line 334 "../src/Widgets/MediaPlayer.vala"
	_tmp155_ = self->priv->m_display;
#line 334 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp155_) {
#line 334 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_ALL:
#line 2358 "MediaPlayer.c"
		{
			GtkButton* _tmp156_;
			const gchar* _tmp157_;
			gchar* _tmp158_;
			gchar* _tmp159_;
			const gchar* _tmp160_;
			gchar* _tmp161_;
			gchar* _tmp162_;
#line 337 "../src/Widgets/MediaPlayer.vala"
			_tmp156_ = self->priv->m_labelButton;
#line 337 "../src/Widgets/MediaPlayer.vala"
			_tmp157_ = pLabel;
#line 337 "../src/Widgets/MediaPlayer.vala"
			_tmp158_ = g_strconcat (_tmp157_, " / ", NULL);
#line 337 "../src/Widgets/MediaPlayer.vala"
			_tmp159_ = _tmp158_;
#line 337 "../src/Widgets/MediaPlayer.vala"
			_tmp160_ = dLabel;
#line 337 "../src/Widgets/MediaPlayer.vala"
			_tmp161_ = g_strconcat (_tmp159_, _tmp160_, NULL);
#line 337 "../src/Widgets/MediaPlayer.vala"
			_tmp162_ = _tmp161_;
#line 337 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_label (_tmp156_, _tmp162_);
#line 337 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (_tmp162_);
#line 337 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (_tmp159_);
#line 338 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2389 "MediaPlayer.c"
		}
#line 334 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_POS:
#line 2393 "MediaPlayer.c"
		{
			GtkButton* _tmp163_;
			const gchar* _tmp164_;
#line 341 "../src/Widgets/MediaPlayer.vala"
			_tmp163_ = self->priv->m_labelButton;
#line 341 "../src/Widgets/MediaPlayer.vala"
			_tmp164_ = pLabel;
#line 341 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_label (_tmp163_, _tmp164_);
#line 342 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2405 "MediaPlayer.c"
		}
#line 334 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_LEFT:
#line 2409 "MediaPlayer.c"
		{
			GtkButton* _tmp165_;
			const gchar* _tmp166_;
#line 345 "../src/Widgets/MediaPlayer.vala"
			_tmp165_ = self->priv->m_labelButton;
#line 345 "../src/Widgets/MediaPlayer.vala"
			_tmp166_ = rLabel;
#line 345 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_label (_tmp165_, _tmp166_);
#line 346 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2421 "MediaPlayer.c"
		}
		default:
#line 334 "../src/Widgets/MediaPlayer.vala"
		break;
#line 2426 "MediaPlayer.c"
	}
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (rLabel);
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (dLabel);
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (pLabel);
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (hr);
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (mr);
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (sr);
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (hp);
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (mp);
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (sp);
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (hd);
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (md);
#line 250 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (sd);
#line 2452 "MediaPlayer.c"
}


static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
#line 354 "../src/Widgets/MediaPlayer.vala"
	g_atomic_int_inc (&_data32_->_ref_count_);
#line 354 "../src/Widgets/MediaPlayer.vala"
	return _data32_;
#line 2463 "MediaPlayer.c"
}


static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
#line 354 "../src/Widgets/MediaPlayer.vala"
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
#line 2474 "MediaPlayer.c"
		FeedReaderMediaPlayer* self;
#line 354 "../src/Widgets/MediaPlayer.vala"
		self = _data32_->self;
#line 354 "../src/Widgets/MediaPlayer.vala"
		_g_object_unref0 (self);
#line 354 "../src/Widgets/MediaPlayer.vala"
		g_slice_free (Block32Data, _data32_);
#line 2482 "MediaPlayer.c"
	}
}


static gboolean
___lambda100_ (Block32Data* _data32_)
{
	FeedReaderMediaPlayer* self;
	gboolean result = FALSE;
	GtkScale* _tmp0_;
	gdouble _tmp1_;
#line 358 "../src/Widgets/MediaPlayer.vala"
	self = _data32_->self;
#line 359 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_scale;
#line 359 "../src/Widgets/MediaPlayer.vala"
	_tmp1_ = _data32_->startValue;
#line 359 "../src/Widgets/MediaPlayer.vala"
	if (gtk_range_get_value ((GtkRange*) _tmp0_) != _tmp1_) {
#line 2502 "MediaPlayer.c"
		GtkScale* _tmp2_;
#line 361 "../src/Widgets/MediaPlayer.vala"
		_tmp2_ = self->priv->m_scale;
#line 361 "../src/Widgets/MediaPlayer.vala"
		_data32_->startValue = gtk_range_get_value ((GtkRange*) _tmp2_);
#line 362 "../src/Widgets/MediaPlayer.vala"
		result = TRUE;
#line 362 "../src/Widgets/MediaPlayer.vala"
		return result;
#line 2512 "MediaPlayer.c"
	} else {
		gdouble _tmp3_;
#line 366 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_seek_source_id = (guint) 0;
#line 367 "../src/Widgets/MediaPlayer.vala"
		_tmp3_ = _data32_->startValue;
#line 367 "../src/Widgets/MediaPlayer.vala"
		feed_reader_media_player_seek (self, _tmp3_);
#line 368 "../src/Widgets/MediaPlayer.vala"
		result = FALSE;
#line 368 "../src/Widgets/MediaPlayer.vala"
		return result;
#line 2525 "MediaPlayer.c"
	}
}


static gboolean
____lambda100__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda100_ (self);
#line 358 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 2537 "MediaPlayer.c"
}


static gboolean
feed_reader_media_player_valueChanged (FeedReaderMediaPlayer* self,
                                       GtkScrollType scroll,
                                       gdouble new_value)
{
	gboolean result = FALSE;
	GtkScale* _tmp0_;
	guint _tmp1_;
#line 350 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 352 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_scale;
#line 352 "../src/Widgets/MediaPlayer.vala"
	gtk_range_set_value ((GtkRange*) _tmp0_, new_value);
#line 354 "../src/Widgets/MediaPlayer.vala"
	_tmp1_ = self->priv->m_seek_source_id;
#line 354 "../src/Widgets/MediaPlayer.vala"
	if (_tmp1_ == ((guint) 0)) {
#line 2559 "MediaPlayer.c"
		Block32Data* _data32_;
#line 354 "../src/Widgets/MediaPlayer.vala"
		_data32_ = g_slice_new0 (Block32Data);
#line 354 "../src/Widgets/MediaPlayer.vala"
		_data32_->_ref_count_ = 1;
#line 354 "../src/Widgets/MediaPlayer.vala"
		_data32_->self = g_object_ref (self);
#line 356 "../src/Widgets/MediaPlayer.vala"
		_data32_->startValue = new_value;
#line 358 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_seek_source_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ____lambda100__gsource_func, block32_data_ref (_data32_), block32_data_unref);
#line 354 "../src/Widgets/MediaPlayer.vala"
		block32_data_unref (_data32_);
#line 354 "../src/Widgets/MediaPlayer.vala"
		_data32_ = NULL;
#line 2575 "MediaPlayer.c"
	}
#line 372 "../src/Widgets/MediaPlayer.vala"
	result = TRUE;
#line 372 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 2581 "MediaPlayer.c"
}


static void
feed_reader_media_player_seek (FeedReaderMediaPlayer* self,
                               gdouble new_value)
{
	gint64 dur = 0LL;
	gdouble percent = 0.0;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	gint64 pos = 0LL;
	GstElement* _tmp2_;
	GtkButton* _tmp3_;
	GtkImage* _tmp4_;
	GstElement* _tmp5_;
#line 375 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 378 "../src/Widgets/MediaPlayer.vala"
	percent = new_value / 100.0;
#line 379 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 379 "../src/Widgets/MediaPlayer.vala"
	gst_element_query_duration (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 379 "../src/Widgets/MediaPlayer.vala"
	dur = _tmp1_;
#line 380 "../src/Widgets/MediaPlayer.vala"
	pos = (gint64) (percent * ((gdouble) dur));
#line 381 "../src/Widgets/MediaPlayer.vala"
	_tmp2_ = self->priv->m_player;
#line 381 "../src/Widgets/MediaPlayer.vala"
	gst_element_seek_simple (_tmp2_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH | GST_SEEK_FLAG_KEY_UNIT, pos);
#line 383 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = self->priv->m_playButton;
#line 383 "../src/Widgets/MediaPlayer.vala"
	_tmp4_ = self->priv->m_pauseIcon;
#line 383 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp3_, (GtkWidget*) _tmp4_);
#line 384 "../src/Widgets/MediaPlayer.vala"
	_tmp5_ = self->priv->m_player;
#line 384 "../src/Widgets/MediaPlayer.vala"
	gst_element_set_state (_tmp5_, GST_STATE_PLAYING);
#line 2624 "MediaPlayer.c"
}


static void
feed_reader_media_player_toggleMute (FeedReaderMediaPlayer* self)
{
	gboolean _tmp0_;
#line 387 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 389 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_muted;
#line 389 "../src/Widgets/MediaPlayer.vala"
	if (_tmp0_) {
#line 2638 "MediaPlayer.c"
		GtkButton* _tmp1_;
		GtkImage* _tmp2_;
		GtkButton* _tmp3_;
		GstElement* _tmp4_;
#line 391 "../src/Widgets/MediaPlayer.vala"
		_tmp1_ = self->priv->m_muteButton;
#line 391 "../src/Widgets/MediaPlayer.vala"
		_tmp2_ = self->priv->m_noiseIcon;
#line 391 "../src/Widgets/MediaPlayer.vala"
		gtk_button_set_image (_tmp1_, (GtkWidget*) _tmp2_);
#line 392 "../src/Widgets/MediaPlayer.vala"
		_tmp3_ = self->priv->m_muteButton;
#line 392 "../src/Widgets/MediaPlayer.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, FEED_READER_MEDIA_BUTTON_MUTE);
#line 393 "../src/Widgets/MediaPlayer.vala"
		_tmp4_ = self->priv->m_player;
#line 393 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp4_, "volume", 1.0, NULL);
#line 394 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_muted = FALSE;
#line 2659 "MediaPlayer.c"
	} else {
		GtkButton* _tmp5_;
		GtkImage* _tmp6_;
		GtkButton* _tmp7_;
		GstElement* _tmp8_;
#line 398 "../src/Widgets/MediaPlayer.vala"
		_tmp5_ = self->priv->m_muteButton;
#line 398 "../src/Widgets/MediaPlayer.vala"
		_tmp6_ = self->priv->m_muteIcon;
#line 398 "../src/Widgets/MediaPlayer.vala"
		gtk_button_set_image (_tmp5_, (GtkWidget*) _tmp6_);
#line 399 "../src/Widgets/MediaPlayer.vala"
		_tmp7_ = self->priv->m_muteButton;
#line 399 "../src/Widgets/MediaPlayer.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, FEED_READER_MEDIA_BUTTON_UNMUTE);
#line 400 "../src/Widgets/MediaPlayer.vala"
		_tmp8_ = self->priv->m_player;
#line 400 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp8_, "volume", 0.0, NULL);
#line 401 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_muted = TRUE;
#line 2681 "MediaPlayer.c"
	}
}


static gboolean
feed_reader_media_player_busCallback (FeedReaderMediaPlayer* self,
                                      GstBus* bus,
                                      GstMessage* message)
{
	gboolean result = FALSE;
	GstMessageType _tmp0_;
#line 405 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 405 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 405 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 407 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = message->type;
#line 407 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp0_) {
#line 407 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_ERROR:
#line 2705 "MediaPlayer.c"
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp1_ = NULL;
			gchar* _tmp2_ = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GstElement* _tmp7_;
#line 412 "../src/Widgets/MediaPlayer.vala"
			gst_message_parse_error (message, &_tmp1_, &_tmp2_);
#line 412 "../src/Widgets/MediaPlayer.vala"
			_g_error_free0 (err);
#line 412 "../src/Widgets/MediaPlayer.vala"
			err = _tmp1_;
#line 412 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (debug);
#line 412 "../src/Widgets/MediaPlayer.vala"
			debug = _tmp2_;
#line 413 "../src/Widgets/MediaPlayer.vala"
			_tmp3_ = err;
#line 413 "../src/Widgets/MediaPlayer.vala"
			_tmp4_ = _tmp3_->message;
#line 413 "../src/Widgets/MediaPlayer.vala"
			_tmp5_ = g_strconcat ("MediaPlayer: ", _tmp4_, NULL);
#line 413 "../src/Widgets/MediaPlayer.vala"
			_tmp6_ = _tmp5_;
#line 413 "../src/Widgets/MediaPlayer.vala"
			feed_reader_logger_error (_tmp6_);
#line 413 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (_tmp6_);
#line 414 "../src/Widgets/MediaPlayer.vala"
			_tmp7_ = self->priv->m_player;
#line 414 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp7_, GST_STATE_NULL);
#line 415 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (debug);
#line 415 "../src/Widgets/MediaPlayer.vala"
			_g_error_free0 (err);
#line 415 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2748 "MediaPlayer.c"
		}
#line 407 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_EOS:
#line 2752 "MediaPlayer.c"
		{
			GstElement* _tmp8_;
			GtkButton* _tmp9_;
			GtkImage* _tmp10_;
#line 418 "../src/Widgets/MediaPlayer.vala"
			_tmp8_ = self->priv->m_player;
#line 418 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp8_, GST_STATE_READY);
#line 419 "../src/Widgets/MediaPlayer.vala"
			_tmp9_ = self->priv->m_playButton;
#line 419 "../src/Widgets/MediaPlayer.vala"
			_tmp10_ = self->priv->m_playIcon;
#line 419 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_image (_tmp9_, (GtkWidget*) _tmp10_);
#line 420 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2769 "MediaPlayer.c"
		}
#line 407 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_BUFFERING:
#line 2773 "MediaPlayer.c"
		{
			gint percent = 0;
			gint _tmp11_ = 0;
			gint _tmp12_;
#line 423 "../src/Widgets/MediaPlayer.vala"
			percent = 0;
#line 424 "../src/Widgets/MediaPlayer.vala"
			gst_message_parse_buffering (message, &_tmp11_);
#line 424 "../src/Widgets/MediaPlayer.vala"
			percent = _tmp11_;
#line 425 "../src/Widgets/MediaPlayer.vala"
			_tmp12_ = percent;
#line 425 "../src/Widgets/MediaPlayer.vala"
			if (_tmp12_ < 100) {
#line 2788 "MediaPlayer.c"
				GstElement* _tmp13_;
				FeedReaderMediaType _tmp14_;
#line 427 "../src/Widgets/MediaPlayer.vala"
				_tmp13_ = self->priv->m_player;
#line 427 "../src/Widgets/MediaPlayer.vala"
				gst_element_set_state (_tmp13_, GST_STATE_PAUSED);
#line 429 "../src/Widgets/MediaPlayer.vala"
				_tmp14_ = self->priv->m_type;
#line 429 "../src/Widgets/MediaPlayer.vala"
				if (_tmp14_ == FEED_READER_MEDIA_TYPE_VIDEO) {
#line 2799 "MediaPlayer.c"
					GtkLabel* _tmp15_;
					gint _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					GtkLabel* _tmp21_;
#line 431 "../src/Widgets/MediaPlayer.vala"
					_tmp15_ = self->priv->m_bufferLabel;
#line 431 "../src/Widgets/MediaPlayer.vala"
					_tmp16_ = percent;
#line 431 "../src/Widgets/MediaPlayer.vala"
					_tmp17_ = g_strdup_printf ("%i", _tmp16_);
#line 431 "../src/Widgets/MediaPlayer.vala"
					_tmp18_ = _tmp17_;
#line 431 "../src/Widgets/MediaPlayer.vala"
					_tmp19_ = g_strconcat (_tmp18_, "%", NULL);
#line 431 "../src/Widgets/MediaPlayer.vala"
					_tmp20_ = _tmp19_;
#line 431 "../src/Widgets/MediaPlayer.vala"
					gtk_label_set_text (_tmp15_, _tmp20_);
#line 431 "../src/Widgets/MediaPlayer.vala"
					_g_free0 (_tmp20_);
#line 431 "../src/Widgets/MediaPlayer.vala"
					_g_free0 (_tmp18_);
#line 432 "../src/Widgets/MediaPlayer.vala"
					_tmp21_ = self->priv->m_bufferLabel;
#line 432 "../src/Widgets/MediaPlayer.vala"
					gtk_widget_show ((GtkWidget*) _tmp21_);
#line 2829 "MediaPlayer.c"
				} else {
					GtkStack* _tmp22_;
					GtkSpinner* _tmp23_;
#line 436 "../src/Widgets/MediaPlayer.vala"
					_tmp22_ = self->priv->m_playStack;
#line 436 "../src/Widgets/MediaPlayer.vala"
					gtk_stack_set_visible_child_name (_tmp22_, "spinner");
#line 437 "../src/Widgets/MediaPlayer.vala"
					_tmp23_ = self->priv->m_playSpinner;
#line 437 "../src/Widgets/MediaPlayer.vala"
					gtk_spinner_start (_tmp23_);
#line 2841 "MediaPlayer.c"
				}
			} else {
				GstElement* _tmp24_;
				FeedReaderMediaType _tmp25_;
#line 442 "../src/Widgets/MediaPlayer.vala"
				_tmp24_ = self->priv->m_player;
#line 442 "../src/Widgets/MediaPlayer.vala"
				gst_element_set_state (_tmp24_, GST_STATE_PLAYING);
#line 443 "../src/Widgets/MediaPlayer.vala"
				_tmp25_ = self->priv->m_type;
#line 443 "../src/Widgets/MediaPlayer.vala"
				if (_tmp25_ == FEED_READER_MEDIA_TYPE_VIDEO) {
#line 2854 "MediaPlayer.c"
					GtkLabel* _tmp26_;
#line 444 "../src/Widgets/MediaPlayer.vala"
					_tmp26_ = self->priv->m_bufferLabel;
#line 444 "../src/Widgets/MediaPlayer.vala"
					gtk_widget_hide ((GtkWidget*) _tmp26_);
#line 2860 "MediaPlayer.c"
				} else {
					GtkStack* _tmp27_;
#line 446 "../src/Widgets/MediaPlayer.vala"
					_tmp27_ = self->priv->m_playStack;
#line 446 "../src/Widgets/MediaPlayer.vala"
					gtk_stack_set_visible_child_name (_tmp27_, "button");
#line 2867 "MediaPlayer.c"
				}
			}
#line 448 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2872 "MediaPlayer.c"
		}
#line 407 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_STATE_CHANGED:
#line 2876 "MediaPlayer.c"
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp28_ = 0;
			GstState _tmp29_ = 0;
			GstState _tmp30_ = 0;
#line 454 "../src/Widgets/MediaPlayer.vala"
			gst_message_parse_state_changed (message, &_tmp28_, &_tmp29_, &_tmp30_);
#line 454 "../src/Widgets/MediaPlayer.vala"
			oldstate = _tmp28_;
#line 454 "../src/Widgets/MediaPlayer.vala"
			newstate = _tmp29_;
#line 454 "../src/Widgets/MediaPlayer.vala"
			pending = _tmp30_;
#line 455 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2894 "MediaPlayer.c"
		}
		default:
#line 407 "../src/Widgets/MediaPlayer.vala"
		break;
#line 2899 "MediaPlayer.c"
	}
#line 457 "../src/Widgets/MediaPlayer.vala"
	result = TRUE;
#line 457 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 2905 "MediaPlayer.c"
}


static void
feed_reader_media_player_onAllocation (FeedReaderMediaPlayer* self,
                                       GtkAllocation* allocation)
{
	gdouble _tmp0_;
#line 460 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 460 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (allocation != NULL);
#line 462 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_aspectRatio;
#line 462 "../src/Widgets/MediaPlayer.vala"
	if (_tmp0_ != ((gdouble) 0)) {
#line 2922 "MediaPlayer.c"
		gdouble width = 0.0;
		GtkAllocation _tmp1_;
		gint _tmp2_;
		gint height = 0;
		gdouble _tmp3_;
		gdouble _tmp4_;
		GtkWidget* _tmp5_;
		gint _tmp6_;
#line 464 "../src/Widgets/MediaPlayer.vala"
		_tmp1_ = *allocation;
#line 464 "../src/Widgets/MediaPlayer.vala"
		_tmp2_ = _tmp1_.width;
#line 464 "../src/Widgets/MediaPlayer.vala"
		width = (gdouble) _tmp2_;
#line 465 "../src/Widgets/MediaPlayer.vala"
		_tmp3_ = width;
#line 465 "../src/Widgets/MediaPlayer.vala"
		_tmp4_ = self->priv->m_aspectRatio;
#line 465 "../src/Widgets/MediaPlayer.vala"
		height = (gint) (_tmp3_ / _tmp4_);
#line 466 "../src/Widgets/MediaPlayer.vala"
		_tmp5_ = self->priv->m_videoWidget;
#line 466 "../src/Widgets/MediaPlayer.vala"
		_tmp6_ = height;
#line 466 "../src/Widgets/MediaPlayer.vala"
		gtk_widget_set_size_request (_tmp5_, -1, _tmp6_);
#line 2949 "MediaPlayer.c"
	}
}


void
feed_reader_media_player_kill (FeedReaderMediaPlayer* self)
{
	GstElement* _tmp0_;
#line 470 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 472 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 472 "../src/Widgets/MediaPlayer.vala"
	gst_element_set_state (_tmp0_, GST_STATE_NULL);
#line 473 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 2966 "MediaPlayer.c"
}


static void
feed_reader_media_player_class_init (FeedReaderMediaPlayerClass * klass)
{
#line 16 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/Widgets/MediaPlayer.vala"
	g_type_class_adjust_private_offset (klass, &FeedReaderMediaPlayer_private_offset);
#line 16 "../src/Widgets/MediaPlayer.vala"
	G_OBJECT_CLASS (klass)->finalize = feed_reader_media_player_finalize;
#line 16 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL] = g_signal_new ("loaded", FEED_READER_TYPE_MEDIA_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2981 "MediaPlayer.c"
}


static void
feed_reader_media_player_instance_init (FeedReaderMediaPlayer * self)
{
#line 16 "../src/Widgets/MediaPlayer.vala"
	self->priv = feed_reader_media_player_get_instance_private (self);
#line 28 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_margin = 20;
#line 34 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_muted = FALSE;
#line 35 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_aspectRatio = 0.0;
#line 36 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_seek_source_id = (guint) 0;
#line 39 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_display = FEED_READER_DISPLAY_POSITION_ALL;
#line 3000 "MediaPlayer.c"
}


static void
feed_reader_media_player_finalize (GObject * obj)
{
	FeedReaderMediaPlayer * self;
#line 16 "../src/Widgets/MediaPlayer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayer);
#line 18 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_player);
#line 19 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_videoWidget);
#line 20 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playStack);
#line 21 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playButton);
#line 22 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playSpinner);
#line 23 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteButton);
#line 24 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeButton);
#line 25 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_scale);
#line 26 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_labelButton);
#line 27 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_bufferLabel);
#line 29 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playIcon);
#line 30 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_pauseIcon);
#line 31 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteIcon);
#line 32 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_noiseIcon);
#line 33 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeIcon);
#line 38 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (self->priv->m_URL);
#line 16 "../src/Widgets/MediaPlayer.vala"
	G_OBJECT_CLASS (feed_reader_media_player_parent_class)->finalize (obj);
#line 3044 "MediaPlayer.c"
}


GType
feed_reader_media_player_get_type (void)
{
	static volatile gsize feed_reader_media_player_type_id__volatile = 0;
	if (g_once_init_enter (&feed_reader_media_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FeedReaderMediaPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feed_reader_media_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedReaderMediaPlayer), 0, (GInstanceInitFunc) feed_reader_media_player_instance_init, NULL };
		GType feed_reader_media_player_type_id;
		feed_reader_media_player_type_id = g_type_register_static (gtk_box_get_type (), "FeedReaderMediaPlayer", &g_define_type_info, 0);
		FeedReaderMediaPlayer_private_offset = g_type_add_instance_private (feed_reader_media_player_type_id, sizeof (FeedReaderMediaPlayerPrivate));
		g_once_init_leave (&feed_reader_media_player_type_id__volatile, feed_reader_media_player_type_id);
	}
	return feed_reader_media_player_type_id__volatile;
}



